
#include "stdafx.h"
#include "Pop3.h"

#include "..\..\etc\IoIni.h"
#include "..\..\etc\LogPlus.h"


#include "..\..\etc\LogPlus.h"


#include "..\MailEnc.h"


nsSvcMHttp::Pop3Manager::Pop3Manager( void )
{
	m_s = nullptr;
	m_arMailDatas = nullptr;
}


nsSvcMHttp::Pop3Manager::~Pop3Manager( void )
{
	if ( m_s != nullptr ) {

		try {
			m_s->Close();
			delete m_s;
		} catch ( System::Exception ^e ) {
			delete e;
		}
		m_s = nullptr;
	}

	EraseMailData();
}

bool nsSvcMHttp::Pop3Manager::ConnectPop3( void )
{
	bool blRet = false;


	LogP	^pLogP = gcnew LogP();

	pLogP->LogOFWithDate( 0 , 
		"Pop3Manager::ConnectPop3 : " + __LINE__ + 
		": CreateReadSocket Ăяo" );

	Socket ^s = CreateMailReadSocket();

	if ( s == nullptr ) {
		delete pLogP;
		return blRet;
	}
	m_s = s;






	/***********************************/
	/* Mf[^Ď                  */
	/* +OK HogeHoge POP3 server ready. */
	/***********************************/

	array<Byte>		^byarRcv = nullptr;

	pLogP->LogOFWithDate( 0 , 
		"Pop3Manager::ConnectPop3 : " + __LINE__ + 
		": ڑRecieve Ăяo" );

	int nRcv = RcvDataInPop3( byarRcv, 2, true );
	if ( nRcv < 0 ) {
		m_s->Close();
		delete m_s;
		m_s = nullptr;

		delete pLogP;

		delete byarRcv;

		return blRet;
	}


	String			^strRcv
		= System::Text::Encoding::ASCII->GetString( byarRcv );
	
	delete byarRcv;



	/* +OK  */
	bool blErr = false;
	if ( strRcv->Length < 4 ) {
		pLogP->LogOFWithDate( 0 , 
			"Pop3Manager::ConnectPop3 : ڑ +OK ZԂĂBG[B" );

		blErr = true;
	}

	if ( blErr == false ) {
		if ( strRcv->Substring(0, 4 ) != "+OK " ) {
			pLogP->LogOFWithDate( 0 , 
				"Pop3Manager::ConnectPop3 : ڑ +OK ȊOT[o[߂ėBG[B" );

			blErr = true;
		}
	}


	int nPos;

	/* POP3 server ready. */
	if ( blErr == false ) {
		nPos = strRcv->IndexOf( " POP3 " );
		if ( nPos < 0 ) {
			pLogP->LogOFWithDate( 0 , 
				"Pop3Manager::ConnectPop3 : ڑ̎Mf[^ɕ\" POP3 \"BG[ B" );

			blErr = true;

		}	
	}

	if ( blErr == false ) {
		if ( strRcv->Substring(nPos ) != " POP3 server ready.\r\n"  && 
			strRcv->Substring(nPos ) != " POP3 server ready.\n" ) {
			pLogP->LogOFWithDate( 0 , 
				"Pop3Manager::ConnectPop3 : ڑ̎Mf[^ɕ\" POP3 server ready.\\n\" BG[B" );

			blErr = true;
		}
	}
	delete strRcv;

	if ( blErr == true ) {
		m_s->Close();
		delete m_s;
		m_s = nullptr;

		delete pLogP;

		return blRet;
	}













	/***********************************/
	/* Mf[^                      */
	/* USER who                        */
	/***********************************/

	array<Byte>		^byarSend = gcnew array<Byte>( 5 );
	byarSend[ 0 ] = 'U';
	byarSend[ 1 ] = 'S';
	byarSend[ 2 ] = 'E';
	byarSend[ 3 ] = 'R';
	byarSend[ 4 ] = ' ';

	
	String ^strUserName = GetUserNameFromIni();
	array<Byte>		^byarBuf = System::Text::Encoding::ASCII->GetBytes( strUserName );
	delete strUserName;

	array<Byte>::Resize( byarSend, byarSend->Length + byarBuf->Length + 2 );
	array<Byte>::Copy( byarBuf, 0,byarSend, 5, byarBuf->Length );
	byarSend[ 5 + byarBuf->Length    ] = '\r';
	byarSend[ 5 + byarBuf->Length +1 ] = '\n';

	delete byarBuf;
	
	
	pLogP->LogOFWithDate( 0 , 
		"Pop3Manager::ConnectPop3 : " + __LINE__ + 
		": USER xxx M" );

	int nSend = m_s->Send( byarSend );
	if ( nSend != byarSend->Length ) {

		pLogP->LogOFWithDate( 0 , 
			"Pop3Manager::ConnectPop3 : USER M悤ƂđSđꂸG[" );

		m_s->Close();
		delete m_s;
		m_s = nullptr;

		delete pLogP;

		delete byarSend;

		return blRet;
	}
	delete byarSend;













	/***********************************/
	/* Mf[^                      */
	/* +OK please send PASS command    */
	/***********************************/
	pLogP->LogOFWithDate( 0 , 
		"Pop3Manager::ConnectPop3 : " + __LINE__ + 
		": USER xxx  Recive Ăяo" );

	nRcv = RcvDataInPop3( byarRcv, 2, false );
	if ( nRcv < 0 ) {

		pLogP->LogOFWithDate( 0 , 
			"Pop3Manager::ConnectPop3 : " + __LINE__ + 
			": USER xxx  Recive ĂяoŃG[" );

		m_s->Close();
		delete s;
		m_s = nullptr;

		delete pLogP;

		delete byarRcv;

		return blRet;
	}


	strRcv = System::Text::Encoding::ASCII->GetString( byarRcv );
	delete byarRcv;
	blRet = true;

	if ( strRcv->Length < 28 ) {
		pLogP->LogOFWithDate( 0 , 
			"Pop3Manager::ConnectPop3 : USER xxx M̎Mf[^Z߂ăG[B" );
		blRet = false;
	}
	if ( strRcv->Substring( 0, 28 ) != "+OK please send PASS command" ) {
		pLogP->LogOFWithDate( 0 , 
			"Pop3Manager::ConnectPop3 : USER xxx M̎Mf[^ \"OK please send PASS command\" BG[B" );
		blRet = false;
	}

	if ( blRet == false ) {

		m_s->Close();
		delete m_s;
		m_s = nullptr;

		delete pLogP;

		delete strRcv;

		return blRet;
	}









	/***********************************/
	/* Mf[^                      */
	/* PASS what                       */
	/***********************************/

	byarSend = gcnew array<Byte>( 5 );
	byarSend[ 0 ] = 'P';
	byarSend[ 1 ] = 'A';
	byarSend[ 2 ] = 'S';
	byarSend[ 3 ] = 'S';
	byarSend[ 4 ] = ' ';


	String		^strPasswd = GetPasswordFromIni();
	byarBuf = System::Text::Encoding::ASCII->GetBytes( strPasswd );
	delete strPasswd;

	array<Byte>::Resize( byarSend, byarSend->Length + byarBuf->Length + 2 );
	array<Byte>::Copy( byarBuf, 0,byarSend, 5, byarBuf->Length );
	byarSend[ 5 + byarBuf->Length    ] = '\r';
	byarSend[ 5 + byarBuf->Length +1 ] = '\n';

	delete byarBuf;


	pLogP->LogOFWithDate( 0 , 
		"Pop3Manager::ConnectPop3 : " + __LINE__ + 
		": PASS xxx M" );

	nSend = m_s->Send( byarSend );
	if ( nSend != byarSend->Length ) {

		pLogP->LogOFWithDate( 0 , 
			"Pop3Manager::ConnectPop3 : PASS xxx M悤ƂđSđꂸG[" );


		m_s->Close();
		delete m_s;
		m_s = nullptr;

		delete pLogP;

		delete byarSend;

		return blRet;
	}
	delete byarSend;













	/***********************************/
	/* Mf[^                      */
	/* +OK j-klein is welcome here     */
	/***********************************/
	pLogP->LogOFWithDate( 0 , 
		"Pop3Manager::ConnectPop3 : " + __LINE__ + 
		": PASS xxx M Recceive Ăяo" );

	nRcv = RcvDataInPop3( byarRcv, 2, false );
	if ( nRcv < 0 ) {

		pLogP->LogOFWithDate( 0 , 
			"Pop3Manager::ConnectPop3 : OK j-klein is welcome here MɃG[" );


		m_s->Close();
		delete m_s;
		m_s = nullptr;

		delete pLogP;

		delete byarRcv;

		return blRet;
	}






	strRcv = System::Text::Encoding::ASCII->GetString( byarRcv );
	delete byarRcv;

	strUserName = GetUserNameFromIni();
	String  ^strDiff1
		= String::Concat( "+OK ", strUserName, " is welcome here", "\r\n" );
	String  ^strDiff2
		= String::Concat( "+OK ", strUserName, " is welcome here", "\n" );
	delete strUserName;

	if ( strRcv != strDiff1   &&
		 strRcv != strDiff2 ) {

		pLogP->LogOFWithDate( 0 , 
			"Pop3Manager::ConnectPop3 : PASS M̎Mf[^ \"" + 
			strUserName + 
			"\" Ȃ߃G[" );


		m_s->Close();
		delete m_s;
		m_s = nullptr;

		delete pLogP;

		delete strRcv;
		delete strDiff1;
		delete strDiff2;

		return blRet;	
	}
	delete strRcv;
	delete strDiff1;
	delete strDiff2;






	delete pLogP;

	return true;
}




System::Net::Sockets::Socket^ nsSvcMHttp::Pop3Manager::CreateMailReadSocket( void )
{

	Socket		^s_ret = nullptr;
	String		^strHostString = gcnew String( "localhost" );
	Int32		^int32Port = nullptr;

	IniInfo		^pIniInfo = gcnew IniInfo();
	bool		blRet;

	blRet = pIniInfo->ReadIni(
		IniInfo::KeyTable::STR_MAILMANAGE_POLLMAILSVR_SVRNAME , 
		strHostString );

	if ( blRet == false ) {
		delete strHostString;
		delete pIniInfo;
		return s_ret;
	}

	blRet = pIniInfo->ReadIni(
		IniInfo::KeyTable::STR_MAILMANAGE_POLLMAILSVR_SVRPORT , 
		int32Port );

	if ( blRet == false ) {
		delete strHostString;
		delete pIniInfo;
		delete int32Port;
		return s_ret;
	}


	
	IPHostEntry^ hostEntry = nullptr;
	try {
		hostEntry = Dns::GetHostEntry( strHostString );
	} catch ( Exception ^e ) {
		e = e;
		return s_ret;
	}


	//delete HostString;

	//hostEntry = Dns::GetHostEntry( "127.0.0.1" );
	//hostEntry = Dns::GetHostEntry( "192.168.33.194" );
	//hostEntry = Dns::GetHostEntry( strHostString );


	System::Collections::IEnumerator^ myEnum = hostEntry->AddressList->GetEnumerator();
	while ( myEnum->MoveNext() )
	{
		IPAddress^ address = safe_cast<IPAddress^>(myEnum->Current);
		IPEndPoint^ endPoint = gcnew IPEndPoint( address, (int)int32Port );
		Socket^ tmpS = gcnew Socket( endPoint->AddressFamily,SocketType::Stream,ProtocolType::Tcp );

		try {
			tmpS->Connect( endPoint );


		} catch ( Exception^ e ) {
			if ( e == e )
				e = e; 

			delete strHostString;
			delete pIniInfo;
			delete int32Port;

			delete address;
			delete endPoint;
			delete tmpS;
			return s_ret;

		}

		if ( tmpS->Connected )
		{
			/* zXgA|[g\Pbg擾 */
			s_ret = tmpS;
			break;
		} else {
		 continue;
		}
	}

	if ( s_ret == nullptr ) {
		/* \Pbg̐ڑs */

		delete strHostString;
		delete pIniInfo;
		delete int32Port;

		return s_ret;
	}

	int		nTimeOut = 1000;
	s_ret->ReceiveTimeout = nTimeOut;




	delete strHostString;
	delete pIniInfo;
	delete int32Port;


	return s_ret;
}











bool nsSvcMHttp::Pop3Manager::GetListPop3( array<int> ^%iarMailCnt )
{
	bool	blRet = false;
	LogP	^pLogP = gcnew LogP();


	/***********************************/
	/* Mf[^                      */
	/* LIST                            */
	/***********************************/

	array<Byte> ^byarSend= gcnew array<Byte>( 6 );
	byarSend[ 0 ] = 'L';
	byarSend[ 1 ] = 'I';
	byarSend[ 2 ] = 'S';
	byarSend[ 3 ] = 'T';
	byarSend[ 4 ] = '\r';
	byarSend[ 5 ] = '\n';


	pLogP->LogOFWithDate( 0 , 
		"Pop3Manager::GetListPop3 : " + __LINE__ + 
		": LIST M" );

	int nSend = m_s->Send( byarSend );
	if ( nSend != byarSend->Length ) {

		pLogP->LogOFWithDate( 0 , 
			"Pop3Manager::GetListPop3 : LIST SđꂸG[" );


		m_s->Close();
		delete m_s;
		m_s = nullptr;

		delete pLogP;

		delete byarSend;

		return blRet;
	}
	delete byarSend;










	/**********************/
	/* Mf[^         */
	/* +OK x messages     */
	/* 1 3187             */
	/* 2 6240             */
	/* 3 7677             */
	/* 4 8926             */
	/* 5 4165             */
	/* 6 3465             */
	/* .                  */
	/**********************/
	pLogP->LogOFWithDate( 0 , 
		"Pop3Manager::GetListPop3 : " + __LINE__ + 
		": LIST M̃f[^M" );


	array<Byte>		^byarRcv = nullptr;
	int nRcv = RcvDataInPop3( byarRcv, 20, true );
	if ( nRcv < 0 ) {

		pLogP->LogOFWithDate( 0 , 
			"Pop3Manager::GetListPop3 : LIST M̎M҂Ń^CAEgG[" );

		m_s->Close();
		delete m_s;
		m_s = nullptr;

		delete pLogP;

		delete byarRcv;

		return blRet;
	}




	String ^strRcv = System::Text::Encoding::ASCII->GetString( byarRcv );
	



	int		nMailNum = 0;

	/* +OK x messages                  */
	int nPos;
	for( nPos = 4; nPos < byarRcv->Length &&
					   byarRcv[ nPos ] >= '0' && 
					   byarRcv[ nPos ] <= '9' ; nPos++ ) {
		nMailNum *= 10;
		nMailNum += byarRcv[ nPos ] - '0';
	}
	
	if ( strRcv->Substring( nPos, 9 ) != " messages" ) {

		pLogP->LogOFWithDate( 0 , 
			"Pop3Manager::GetListPop3 : LIST M̎Mf[^ messages ăG[" );

		m_s->Close();
		delete m_s;
		m_s = nullptr;

		delete pLogP;


		delete byarRcv;
		delete strRcv;

		return blRet;
	}



	/*
	if ( m_arMailDatas != nullptr ) {
		for( int nCnt = 0 ; nCnt < m_arMailDatas->Length ; nCnt++ ) {
			delete m_arMailDatas[ nCnt ];
		}
		delete m_arMailDatas;
	}
	m_arMailDatas = gcnew array<MailDataCage^>( nMailNum );
	for( int nCnt = 0; nCnt < nMailNum; nCnt++ ) {
		m_arMailDatas[ nCnt ] = gcnew MailDataCage();
	}
	*/

	if (iarMailCnt != nullptr ) {
		delete iarMailCnt;
	}
	iarMailCnt = gcnew array<int>( nMailNum );

	/* [Mpf[^̈̊m */
	EraseMailData();
	m_arMailDatas = gcnew array<MailDataCage^>( nMailNum );
	for ( int nCnt = 0 ; nCnt < nMailNum ; nCnt++ ) {
		m_arMailDatas[ nCnt ] = gcnew MailDataCage();
	}


	nPos = strRcv->IndexOf( " messages" );
	nPos += 9;
	if (        strRcv->Substring( nPos , 1) == "\n" ) {
		nPos += 1;
	} else if ( strRcv->Substring( nPos , 2) == "\r\n" ) {
		nPos += 2;
	}



	/* 1 3187             */
	/* 2 6240             */
	/* 3 7677             */
	/*   ....             */
	/* m 4165             */
	/* n 3465             */
	/* .                  */
	bool blErr = false;
	for ( int nCnt = 0; nCnt < nMailNum; nCnt++ ) {


		if ( nPos >= byarRcv->Length ) {
			/* G[ */
			blErr = true;
			break;
		}

		int nTemp;
		nTemp = 0;
		for( ; nPos < byarRcv->Length; nPos++ ) {
			
			if ( ( byarRcv[ nPos ] < '0' ) ||
				( byarRcv[ nPos ] > '9' ) ) {
				break;
			}
	
			nTemp *= 10;
			nTemp += byarRcv[ nPos ] - '0';
			
		}
		if ( nPos >= byarRcv->Length ) {
			/* G[ */
			blErr = true;
			break;
		}

		m_arMailDatas[ nCnt ]->m_MessageNo = nTemp;
		iarMailCnt[ nCnt ] = nTemp;


		/* ̍s܂œǂݔ΂ */
		/* r͓̕ǂݎ̂ */
		for( ; nPos < byarRcv->Length; nPos++ ) {
			if ( byarRcv[ nPos ] == '\r' ) {
				nPos++;
				if ( nPos < byarRcv->Length ) {
					if ( byarRcv[ nPos ] == '\n' ) {
						nPos++;
						break;
					}
				}
				nPos--;
			}
			if ( byarRcv[ nPos ] == '\n' ) {
				nPos++;
				break;
			}
		}

	}


	if ( nPos < byarRcv->Length ) {
		if ( byarRcv[ nPos ] != '.' ) {
			blErr = true;
		}
	} else {
		blErr = true;
	}


	delete strRcv;
	delete byarRcv;


	if ( blErr == true ) {

		pLogP->LogOFWithDate( 0 , 
			"Pop3Manager::GetListPop3 : LIST M̎Mf[^𐸍ĔFoȂ`̂߃G[" );

		m_s->Close();
		delete m_s;
		m_s = nullptr;

		delete pLogP;


		EraseMailData();

		delete iarMailCnt;
		iarMailCnt = nullptr;

		return blRet;
	}







	delete pLogP;

	return true;
}









bool nsSvcMHttp::Pop3Manager::RcvPop3( int nMailNum )
{


	LogP	^pLogP = gcnew LogP();


	/* [{̃f[^̎擾 */
	pLogP->LogOFWithDate( 0 , 
		"Pop3Manager::RcvPop3 : " + __LINE__ + 
		": RcvRawMailInPop3() Ăяo" );

	bool blRcvOK = RcvRawMailInPop3( nMailNum );
	if ( blRcvOK == false ) {

		pLogP->LogOFWithDate( 0 , 
			"Pop3Manager::RcvPop3 : RcvRawMailInPop3 ĂяoŃG[" );

		m_s->Close();
		delete m_s;
		m_s = nullptr;

		return false;
	}

	/* [tH[}bg */
	pLogP->LogOFWithDate( 0 , 
		"Pop3Manager::RcvPop3 : " + __LINE__ + 
		": FormatMailDataCages() Ăяo" );
	FormatMailDataCages( m_arMailDatas );


	delete pLogP;

	return true;
}








bool nsSvcMHttp::Pop3Manager::RcvRawMailInPop3( int nMaxMsgNo )
{
	bool blRet = false;

	LogP	^pLogP = gcnew LogP();


	/* [{̃f[^̎擾 */
	/***********************************/
	/* Mf[^                      */
	/*  RETR n						   */
	/* Mf[^                      */
	/*  +OK xxx octets                 */
	/*  Return-Path: <ԐMAhX>    */
	/*  Received: <ԐMAhX>       */
	/***********************************/


	/* [{̎擾͂ȂsȓB  */
	/* Mf[^܂܂肷  */


	/* [e̎擾 */
	bool blErr = false;
	for( int nMailCnt = 0; nMailCnt < nMaxMsgNo ; nMailCnt++ ) {

		/* Mf[^                      */
		/*  RETR n						   */

		String ^strRetr_N;
		strRetr_N = String::Concat( 
					"RETR ", 
					System::Convert::ToString( m_arMailDatas[ nMailCnt ]->m_MessageNo ) , 
					"\r\n"  );
		array<Byte> ^byarSend = System::Text::Encoding::ASCII->GetBytes( strRetr_N );
		delete strRetr_N;

		int nSend = m_s->Send( byarSend );
		
		if ( nSend != byarSend->Length ) {
			blErr = true;
			delete strRetr_N;
			break;
		}

		delete strRetr_N;
		delete byarSend;



		/* Mf[^							   */
		/*  +OK xxx octets						   */
		/*  Return-Path: <ԐM[AhX>	   */
		/*  Received: (...̃f[^...) for<ԐM[AhX> */
		/*  Received: (...̃f[^...) for<ԐM[AhX> */
		/*  Received: (...̃f[^...) for<ԐM[AhX> */
		/*  ..... */
		/*  xxx: ..... 	   */
		/*  xxx: ..... 	   */
		/*  xxx: ..... 	   */
		/*  xxx: ..... 	   */
		/*  Subject: () 	   */
		/*  xxx: ..... 	   */
		/*  xxx: ..... 	   */



	


		/* Tbԍŏ̎M҂ */
		/* Vf[^邽тɃp[VOA30bԑ҂ */
		/* f[^ȂI */

		array<Byte>		^byarRcv = nullptr;
		String			^strRcv = nullptr;
		bool			blReadDone = false;

		DateTime	dteTimeOut;
		byarRcv = gcnew array<Byte>( 0 );

		dteTimeOut = System::DateTime::Now.AddSeconds( 120 );

		int	nRcvSize;

		nRcvSize = 20;

		while ( System::DateTime::Compare( dteTimeOut, System::DateTime::Now ) > 0  ) {



		

			System::Threading::Thread::Sleep( 50 );


			if ( strRcv != nullptr ) {
				delete strRcv;
			}
			strRcv = nullptr;

			int nRcv = RcvDataInPop3MainData( nRcvSize, byarRcv, 5 );
			if ( nRcv < 0 ) {
				pLogP->LogOFWithDate( 0 , 
					"Pop3Manager::RcvRawMailInPop3 :RcvDataInPop3MainData ĂяoŃG[(gC)" );
				continue;
			}

			strRcv = System::Text::Encoding::ASCII->GetString( byarRcv );

			/* +OK NNN octets */
			int nPos = 0;
			if ( strRcv->Length < 4 ) {
				pLogP->LogOFWithDate( 0 , 
					"Pop3Manager::RcvRawMailInPop3 :+OK NNN octets TCYG[(gC)" );
				continue;
			} else if ( strRcv->Substring( 0, 4 ) != "+OK " ) {
				pLogP->LogOFWithDate( 0 , 
					"Pop3Manager::RcvRawMailInPop3 :+OK NNN octets +OK ȂăG[(gC)" );
				continue;
			}
			nPos += 4;

			int nSizeRead;
			nSizeRead = 0;
			while ( nPos < byarRcv->Length ) {
				if ( byarRcv[ nPos ] < '0' ||
					byarRcv[ nPos ] > '9' ) {
					break;
				}
				nSizeRead *= 10;
				nSizeRead += byarRcv[ nPos ] - '0';

				nPos++;
			}
			if ( nPos+8 >= byarRcv->Length ) {
				pLogP->LogOFWithDate( 0 , 
					"Pop3Manager::RcvRawMailInPop3 :+OK NNN octets Qxڂ̃TCYG[(gC)" );
				continue;
			}

			if ( nRcvSize == 20 )		nRcvSize = nSizeRead + 500;







			
			if ( strRcv->Substring( nPos, 7 ) != " octets" ) {
				pLogP->LogOFWithDate( 0 , 
					"Pop3Manager::RcvRawMailInPop3 :+OK NNN octets octets ȂăG[(gC)" );
				continue;
			}
			nPos += 7;

			blErr = true;
			if (  byarRcv[ nPos ] == '\n' ) {
				blErr = false;
				nPos++;
			}
			if (  byarRcv[ nPos ] == '\r' && byarRcv[ nPos+1 ] == '\n' ) {
				blErr = false;
				nPos += 2;
			}
			if ( blErr ) {
				pLogP->LogOFWithDate( 0 , 
					"Pop3Manager::RcvRawMailInPop3 :+OK NNN octets octets ̌sȂăG[(gC)" );
				continue;
			}






















			/* xxxx: yyyy... */
			/* xxxx: yyyy... */
			/* xxxx: yyyy... */
			/* .........     */
			// arMailDatas[ nMailCnt ]->m_srtAttr
			//	= gcnew System::Collections::SortedList();

			while ( nPos < byarRcv->Length ) {

				int nRtnN = nPos;
				/* sʒu */
				while ( 1 ) {
					/* šɃ^uĂA܂͂Qȏ̋󔒂ꍇ */
					/* s܂񂾕s̑Ɣf */

					int nRtnNOld = nRtnN;
					nRtnN = strRcv->IndexOf( "\n",   nRtnN );
					if ( nRtnN < 0 ) {
						nRtnN = strRcv->IndexOf( "\r\n", nRtnNOld );
						if ( nRtnN < 0 ) {
							/* sAG[ */
							pLogP->LogOFWithDate( 0 , 
								"Pop3Manager::RcvRawMailInPop3 :+ǂݎ蒆ɉsȂăG[(gC)" );

							blErr = true;
							break;
						}
						nRtnN++;
					}

					if ( blErr ) 	break;

					if ( nRtnN+2 < strRcv->Length ) {
						if ( byarRcv[ nRtnN + 1 ] != '\t' && 
							(byarRcv[ nRtnN + 1 ] != ' '  && byarRcv[ nRtnN + 2 ] != ' ') 
							) {
							break;
						} else {
							nRtnN++;
						}
					} else {
						break;
					}

				}

				if ( blErr )	break;


				/* sĂ{Ɣ肵 */
				/* ǂݎȂ */
				int nNextRtnN;
				nNextRtnN = nRtnN + 1;
				if ( byarRcv[ nNextRtnN ] == '\r' ) {
					nNextRtnN++;
				}

				if ( byarRcv[ nNextRtnN ] == '\n') {
					nPos =  nNextRtnN + 1;
					break;
				}
				if (byarRcv[ nNextRtnN ] == '\r' && byarRcv[ nNextRtnN+1 ] == '\n' ) {
					nPos =  nNextRtnN + 2;
					break;
				}



				
				int nCollon
					= strRcv->IndexOf( ": ", nPos );
				//if ( nPos > nRtnN ) {
				//
				//}
				if ( nCollon < 0 ) {
					pLogP->LogOFWithDate( 0 , 
						"Pop3Manager::RcvRawMailInPop3 :+ǂݎ蒆 : ȂăG[(gC)" );
					blErr = true;
					break;
				}

				if ( nRtnN < nCollon ) {
					pLogP->LogOFWithDate( 0 , 
						"Pop3Manager::RcvRawMailInPop3 :+ǂݎ蒆 : ̈ʒusOŃG[(gC)" );
					blErr = true;
					break;
				}


				String		^strAttrKey
					= strRcv->Substring( nPos, nCollon + 1 - nPos + 1);
				String		^strAttrData
					= strRcv->Substring( nCollon + 2, nRtnN-1-(nCollon+2)+1 );


				if ( m_arMailDatas[ nMailCnt ]->m_srtAttr == nullptr ) {
					m_arMailDatas[ nMailCnt ]->m_srtAttr
						= gcnew System::Collections::SortedList();
				}

				/* 鑮̏ꍇ */
				/* strAttrXXX Ƃ( XXX=0,1,2,...)  */
				if ( m_arMailDatas[ nMailCnt ]->m_srtAttr->Contains( strAttrKey ) ) {
				
					int nNewKeyCnt = 2;
					String		^strNewKey;

					while ( nNewKeyCnt < 0x7ffe ) {

						strNewKey = String::Concat( 
								strAttrKey, 
								System::Convert::ToString( nNewKeyCnt ) );

						if ( m_arMailDatas[ nMailCnt ]->m_srtAttr->Contains( strNewKey ) == false ) {
							break;
						}
						nNewKeyCnt++;
					}
					delete strAttrKey;
					strAttrKey = strNewKey;
					
				}

				m_arMailDatas[ nMailCnt ]->m_srtAttr->Add( strAttrKey, strAttrData );

				
				nPos = nRtnN + 1;

				if ( nPos >= byarRcv->Length ) {
					pLogP->LogOFWithDate( 0 , 
						"Pop3Manager::RcvRawMailInPop3 :+ǂݎ蒼Ƀf[^sŃG[(gC)" );
					blErr = true;
					break;
				}				

				if ( byarRcv[ nPos ] == '\r' )
					nPos++;
				if ( nPos < byarRcv->Length ) {
					if ( byarRcv[ nPos ] == '\n' )
						nPos++;
				} else {
					pLogP->LogOFWithDate( 0 , 
						"Pop3Manager::RcvRawMailInPop3 :+ǂݎ蒼ɉs߂ŃG[(gC)" );
					blErr = true;
					break;
				}


			}


			if ( blErr )
				continue;


			/* { */
			/*  ......                      */
			/*  ......                      */
			/*  ......                      */
			/*  .         ".\r\n"ŏI   */

			int		nEnd = byarRcv->Length - 1;
			if ( byarRcv[ nEnd ] == '\n' ) {
				nEnd--;
			} else {
				pLogP->LogOFWithDate( 0 , 
						"Pop3Manager::RcvRawMailInPop3 :{I[ɁAŌ\\n߃G[(gC)" );
				continue;
			}
			if ( byarRcv[ nEnd ] == '\r' )
				nEnd--;
			if ( byarRcv[ nEnd ] == '.' ) {
				nEnd--;
			} else {
				pLogP->LogOFWithDate( 0 , 
						"Pop3Manager::RcvRawMailInPop3 :{I[ɁAŌ . ߃G[(gC)" );
				continue;
			}
			if ( byarRcv[ nEnd ] == '\n' )
				nEnd--;
			if ( byarRcv[ nEnd ] == '\r' )
				nEnd--;


			//arMailDatas[ nMailCnt ]->m_byarData
			//	= gcnew array<Byte>(  byarRcv, nPos, nEnd - nPos + 1 );

			m_arMailDatas[ nMailCnt ]->m_byarData = gcnew array<Byte>( nEnd - nPos + 1 );
			array<Byte>::Copy( byarRcv, nPos, m_arMailDatas[ nMailCnt ]->m_byarData, 0, nEnd - nPos + 1 );

			blReadDone = true;
			break;


		}  // while ( System::DateTime::Compare( dteTimeOut, System::DateTime::Now()) > 0  ) {





		if ( byarRcv != nullptr)	delete byarRcv;
		if ( strRcv != nullptr)		delete strRcv;
		byarRcv = nullptr;
		strRcv = nullptr;


		if ( blReadDone == false ) {
			/* ^CAEgG[B */

			pLogP->LogOFWithDate( 0 , 
				"Pop3Manager::RcvRawMailInPop3 : Mf[^p[VÕ^CAEgG[" );


			blErr = true;
			break;
		}


	} // for( int nMailCnt = 0; nMailCnt < nMaxMsgNo ; nMailCnt++ ) {



	if ( blErr == true ) {
		return blRet;
	}

	delete pLogP;


	blRet = true;
	return blRet;


}




























bool nsSvcMHttp::Pop3Manager::FormatMailDataCages( array<MailDataCage^> ^%arMail )
{

	bool		blRet = false;
	nsSvcMHttp::MimeLineEncoding		^pEncData = gcnew nsSvcMHttp::MimeLineEncoding();



	/* [̓emFA̕Kv true Ԃ */
	for ( int nMailCnt = 0 ; nMailCnt < arMail->Length; nMailCnt++ ) {
		
		MailDataCage ^arM = arMail[ nMailCnt ];
		

		
		System::Collections::IList ^ilList = arM->m_srtAttr->GetKeyList();
		for ( int nAttrCnt = 0 ; nAttrCnt < ilList->Count  ; nAttrCnt++ ) {
			
			String	^strKey = static_cast<String^>( ilList[ nAttrCnt ] );
			String	^strData = static_cast<String^>( arM->m_srtAttr[ strKey ] );
				

			strData = pEncData->GetMimeEncoding( strData );

			//arM->m_srtAttr->Values[ strKey ] =
			//	pEncData->GetMimeEncoding(   arM->m_srtAttr->Values[ strKey ] );

			arM->m_srtAttr->SetByIndex( 
					arM->m_srtAttr->IndexOfKey(strKey) , 
					strData	
				);
			
		}




		for ( int nAttrDblCnt = 1 ; ; nAttrDblCnt++ ) {
			String	^strKey = gcnew String( "Received" );

			if ( nAttrDblCnt > 1 ) {
				strKey = String::Concat( strKey, System::Convert::ToString( nAttrDblCnt ) );
			}
			strKey = String::Concat( strKey, ": " );

			if ( arM->m_srtAttr->Contains( strKey )==true ) {
				
				/* M */
				if ( arM->m_strarReciver == nullptr ) {
					arM->m_strarReciver = gcnew array<String^>( 1 );
					arM->m_strarReciver[ 0 ] = 
						static_cast<String^>( arM->m_srtAttr[ strKey ] );
				} else {
					array<String^>::Resize( arM->m_strarReciver, arM->m_strarReciver->Length + 1 );

					arM->m_strarReciver[ arM->m_strarReciver->Length -1 ] =
						static_cast<String^>( arM->m_srtAttr[ strKey ] );

				}

			} else {
				break;
			}
		}




		String	^strSender = gcnew String( "From: " );
		if ( arM->m_srtAttr->Contains( strSender )==true ) {
			
			/* M */
			arM->m_strSender = static_cast<String^>
					( arM->m_srtAttr[ strSender ] );

		} else {

			String	^strReturnPath = gcnew String( "Return-Path: " );
			if ( arM->m_srtAttr->Contains( strReturnPath )==true ) {
				
				/* M */
				arM->m_strSender = static_cast<String^>
						( arM->m_srtAttr[ strReturnPath ] );
			}
			delete strReturnPath;
		}
		delete strSender;


		String	^strSubject = gcnew String( "Subject: " );
		if ( arM->m_srtAttr->Contains( strSubject )==true ) {
			
			/* M */
			arM->m_strSubject = static_cast<String^>
					( arM->m_srtAttr[ strSubject ] );

		}
		delete strSubject;





		/* [wb_̓t */
		/*  [[ɂătH[}bg肵ȂsEEE */


		DateTime		dteMailDate = System::DateTime::MinValue;
		String			^strDateKey = gcnew String( "Date: " );
		if ( arM->m_srtAttr->Contains( strDateKey ) ) {
			
			String		^strDateLine = 
					static_cast<String^>( arM->m_srtAttr[ strDateKey ] );
			array<Byte>	^byarDateLine = System::Text::Encoding::ASCII->GetBytes( strDateLine );
			int			nDatePos = 5;

			Int32		nDate = 0;
			
			/* t */
			while ( byarDateLine[ nDatePos ] != ' ' ) {				
				nDate *= 10;
				nDate += byarDateLine[ nDatePos ] - '0';
				nDatePos++;
			}
			nDatePos++;

			/*  */
			array<Byte>		^byarMonth = gcnew array<Byte>( 3 );
			array<Byte>::Copy( byarDateLine, nDatePos, byarMonth, 0, 3 );
			String			^strMonth = System::Text::Encoding::ASCII->GetString( byarMonth );

			strMonth = strMonth->ToLower();
			Int32		nMonth;

			array<String^>		^strarMonthStr
				= gcnew array<String^>( 12 );
			strarMonthStr[  0 ] = gcnew String ( "jan" );
			strarMonthStr[  1 ] = gcnew String ( "feb" );
			strarMonthStr[  2 ] = gcnew String ( "mar" );
			strarMonthStr[  3 ] = gcnew String ( "apr" );
			strarMonthStr[  4 ] = gcnew String ( "may" );
			strarMonthStr[  5 ] = gcnew String ( "jun" );
			strarMonthStr[  6 ] = gcnew String ( "jul" );
			strarMonthStr[  7 ] = gcnew String ( "aug" );
			strarMonthStr[  8 ] = gcnew String ( "sep" );
			strarMonthStr[  9 ] = gcnew String ( "oct" );
			strarMonthStr[ 10 ] = gcnew String ( "nov" );
			strarMonthStr[ 11 ] = gcnew String ( "dec" );

			for ( int nMonthCnt = 1; nMonthCnt <= 12 ; nMonthCnt++ ) {
				if ( strMonth == strarMonthStr[ nMonthCnt-1 ] ) {
					nMonth = nMonthCnt;
					break;
				}
			}

			for ( int nCnt = 0; nCnt < 12 ; nCnt++ ) {
				delete strarMonthStr[ nCnt ];
			}
			delete strarMonthStr;


			delete byarMonth;
			delete strMonth;
			delete strarMonthStr;
			
			nDatePos += 4;

			/* N */
			Int32		nYear = 0;
			
			while ( byarDateLine[ nDatePos ] != ' ' ) {				
				nYear *= 10;
				nYear += byarDateLine[ nDatePos ] - '0';
				nDatePos++;
			}
			nDatePos++;



			/*  */
			Int32		nHour = 0;
			
			while ( byarDateLine[ nDatePos ] != ':' ) {				
				nHour *= 10;
				nHour += byarDateLine[ nDatePos ] - '0';
				nDatePos++;
			}
			nDatePos++;


			/*  */
			Int32		nMinite = 0;
			
			while ( byarDateLine[ nDatePos ] != ':' ) {				
				nMinite *= 10;
				nMinite += byarDateLine[ nDatePos ] - '0';
				nDatePos++;
			}
			nDatePos++;


			/* b */
			Int32		nSecond = 0;
			
			while ( byarDateLine[ nDatePos ] != ' ' ) {				
				nSecond *= 10;
				nSecond += byarDateLine[ nDatePos ] - '0';
				nDatePos++;
			}
			nDatePos++;



			arM->m_dteDate
				= System::DateTime( nYear, nMonth, nDate, nHour, nMinite, nSecond );


		}
		delete strDateKey;


		/* [{̃GR[h */
		String	^strDataEncKey = gcnew String( "Content-Type: " );
		if ( arM->m_srtAttr->Contains( strDataEncKey )==true ) {

			String ^strDataEncLine
				= static_cast<String^>( arM->m_srtAttr[ strDataEncKey ] );

			strDataEncLine = strDataEncLine->ToLower();

			int nPosCharSet
				= strDataEncLine->IndexOf( "charset=" );
			
			if ( nPosCharSet >= 0 ) {
				
				nPosCharSet += 8;

				String		^strEnc = gcnew String( "" );

				while ( nPosCharSet < strDataEncLine->Length ) {
					String		^strEnd
						= strDataEncLine->Substring( nPosCharSet, 1 );

					if ( strEnd == " "  || strEnd == ";"  || strEnd == ":" ||
						 strEnd == "."  || strEnd == ","  || 
						 strEnd == "\r" || strEnd == "\n"

						) {
						break;
					}
						
					strEnc = String::Concat( strEnc, strEnd );
					nPosCharSet++;
				}

				if ( strEnc->Substring(0, 1 ) == "\"" ) {
					strEnc = strEnc->Substring( 1, strEnc->Length -2 );
				}


				//arM->m_strData =
				try {
				
					array<unsigned char>	^usarEnc
						= gcnew array<unsigned char>( arM->m_byarData->Length );
					for ( int nCnt = 0; nCnt < usarEnc->Length; nCnt++ ) {
						usarEnc[ nCnt ] = static_cast<unsigned char>
							( arM->m_byarData[ nCnt ] );
					}


					arM->m_strData = 
						System::Text::Encoding::GetEncoding( strEnc )->GetString( usarEnc );

					delete usarEnc;

				} catch ( Exception ^e ) {
					delete e;

				}

			}


		} else {

			/* Contents-Type ꍇ */
			/*  plala 瑗ė[΍ */
			//arM->m_strData =
			try {
			
				array<unsigned char>	^usarEnc
					= gcnew array<unsigned char>( arM->m_byarData->Length );
				for ( int nCnt = 0; nCnt < usarEnc->Length; nCnt++ ) {
					usarEnc[ nCnt ] = static_cast<unsigned char>
						( arM->m_byarData[ nCnt ] );
				}


				arM->m_strData = 
					System::Text::Encoding::GetEncoding( "iso-2022-jp" )->GetString( usarEnc );

				delete usarEnc;

			} catch ( Exception ^e ) {
				delete e;

			}


		}


	}

	delete pEncData;


	return blRet;
}
































bool nsSvcMHttp::Pop3Manager::DeletePop3( int nMailCnt )
{

	bool	blRet = false;


	/* w̃[폜悤˗ */

	/* DELE xxx 𑗐M */
	/***********************************/
	/* Mf[^                      */
	/*  DELE x						   */
	/***********************************/
	array<Byte>	^byarSend = System::Text::Encoding::ASCII->GetBytes( 
			String::Concat( "DELE ",
			System::Convert::ToString( m_arMailDatas[ nMailCnt ]->m_MessageNo ), 
			"\r\n" )
		);

	int nSend = m_s->Send( byarSend );
	if ( nSend != byarSend->Length ) {
		delete byarSend;
		return blRet;
	}
	delete byarSend;





	/*********************************************/
	/* Mf[^                                */
	/*  +OK                                      */
	/*********************************************/

	array<Byte>		^byarRcv = nullptr;
	int nRcv = RcvDataInPop3( byarRcv, 2, false );
	String ^strRcv = System::Text::Encoding::ASCII->GetString( byarRcv );
	delete byarRcv;

	String ^strDiff = String::Concat( "+OK" );

	if ( strRcv != String::Concat( strDiff, "\r\n" ) &&
		strRcv != String::Concat( strDiff, "\n" ) ) {
		blRet = false;
	}
	delete strDiff;
	delete strRcv;


	blRet = true;

	return blRet;


}

bool nsSvcMHttp::Pop3Manager::ExitPop3( void )
{
	LogP		^pLogP = gcnew LogP();


	/* QUIT 𑗐M */
	/***********************************/
	/* Mf[^                      */
	/*  QUIT						   */
	/***********************************/
	array<Byte> ^byarSend = 
		System::Text::Encoding::ASCII->GetBytes( "QUIT\r\n" );


	pLogP->LogOFWithDate( 0 , 
			"Pop3Manager::CheckSvrMail : " + __LINE__ + 
			": QUIT M" );

	int nSend = m_s->Send( byarSend );
	
	if ( nSend != byarSend->Length ) {

		pLogP->LogOFWithDate( 0 , 
				"Pop3Manager::CheckSvrMail : QUIT 𑗐M悤ƂđSđMoG[" );


		m_s->Close();
		delete m_s;
		m_s = nullptr;

		delete pLogP;

		delete byarSend;
		/*
		for( int nCnt = 0; nCnt < nMailNum; nCnt++ ) {
			delete m_arMailDatas[ nCnt ];
		}
		delete m_arMailDatas;
		m_arMailDatas = nullptr;

		for( int nCnt = 0; nCnt < arHitList->Count; nCnt++ ) {
			delete arHitList[ nCnt ];
		}
		delete arHitList;
		*/

		return false;
	}




	/*********************************************/
	/* Mf[^                                */
	/*  +OK taxman POP3 server signing off.      */
	/*********************************************/

	array<Byte>		^byarRcv = nullptr;

	pLogP->LogOFWithDate( 0 , 
			"Pop3Manager::CheckSvrMail : " + __LINE__ + 
			": QUIT M Receive Ăяo" );

	int nRcv = RcvDataInPop3( byarRcv, 3, true );
	if ( nRcv < 0 ) {

		/* QUIT MɃT[o[炢Ȃ؂鎖悤Ȃ̂ */
		/* Mf[^Ȍꍇ͉Ȃ */

		/*
		m_pLogP->LogOFWithDate( 0 , 
			"MailReactor::CheckSvrMail : " + __LINE__ + 
			": +OK taxman POP3 server signing off. MɃG[" );

		delete pIniInfo;
		delete strUserName;
		delete strPasswd;
		delete byarSend;

		m_s->Close();
		delete m_s;
		m_s = nullptr;

		for( int nCnt = 0; nCnt < nMailNum; nCnt++ ) {
			delete m_arMailDatas[ nCnt ];
		}
		delete m_arMailDatas;
		m_arMailDatas = nullptr;

		for( int nCnt = 0; nCnt < arHitList->Count; nCnt++ ) {
			delete arHitList[ nCnt ];
		}
		delete arHitList;

		return blRet;
		*/

	} else {
 
	
		pLogP->LogOFWithDate( 0 , 
				"Pop3Manager::CheckSvrMail : " + __LINE__ + 
				": QUIT M Receive Ăяo" );

		//array<Byte>::Resize( byarRcv, nRcv );
		String ^strRcv = System::Text::Encoding::ASCII->GetString( byarRcv );


		String^ strUserName = GetUserNameFromIni();
		String ^strDiff1 = String::Concat( "+OK ", strUserName, " POP3 server signing off.", "\r\n" );
		String ^strDiff2 = String::Concat( "+OK ", strUserName, " POP3 server signing off.", "\n" );
		delete strUserName;

		if ( strRcv != strDiff1 && strRcv != strDiff2 ) {


			pLogP->LogOFWithDate( 0 , 
				"Pop3Manager::CheckSvrMail : QUIT 𑗐M̎Mf[^"
				+ strDiff1 +
				"炸G[" );

			delete byarSend;

			m_s->Close();
			delete m_s;
			m_s = nullptr;

			delete byarRcv;
			delete strRcv;
			delete strDiff1;
			delete strDiff1;


			/*
			for( int nCnt = 0; nCnt < nMailNum; nCnt++ ) {
				delete m_arMailDatas[ nCnt ];
			}
			delete m_arMailDatas;
			m_arMailDatas = nullptr;

			for( int nCnt = 0; nCnt < arHitList->Count; nCnt++ ) {
				delete arHitList[ nCnt ];
			}
			delete arHitList;
			*/

			return false;
		}


		delete strRcv;
		delete strDiff1;
		delete strDiff1;

	}
	delete byarRcv;


	try {
		m_s->Close();
	} catch ( System::Exception ^e ) {
		delete e;
	}
	delete m_s;
	m_s = nullptr;

	delete pLogP;

	return true;
}



System::String^ nsSvcMHttp::Pop3Manager::GetUserNameFromIni( void )
{
	IniInfo		^pIniInfo = gcnew IniInfo();
	String		^strUserName = gcnew String( "anomous" );
	pIniInfo->ReadIni( IniInfo::KeyTable::STR_MAILMANAGE_POLLMAILSVR_USER, 
						strUserName );
	delete pIniInfo;

	return strUserName;
}


System::String^ nsSvcMHttp::Pop3Manager::GetPasswordFromIni( void )
{
	IniInfo		^pIniInfo = gcnew IniInfo();
	String		^strPasswd = gcnew String( "password" );
	pIniInfo->ReadIni( IniInfo::KeyTable::STR_MAILMANAGE_POLLMAILSVR_PASSWORD, 
						strPasswd );
	delete pIniInfo;

	return strPasswd;
}










void nsSvcMHttp::Pop3Manager::EraseMailData( void )
{
	if ( m_arMailDatas != nullptr ) {
		for ( int nCnt = 0 ; nCnt < m_arMailDatas->Length ; nCnt++ ) {
			delete m_arMailDatas[ nCnt ];
		}
		delete m_arMailDatas;
	}
	m_arMailDatas = nullptr;


}