#pragma once


#include "..\MailManage.h"


namespace nsSvcMHttp {

	using namespace		System;

	public ref class Pop3Manager 
	{
	public:
		Pop3Manager();
		~Pop3Manager();

		bool ConnectPop3( void );
		bool GetListPop3( array<int> ^%nMailCnt );
		bool RcvPop3( int nMailNum );
		bool DeletePop3( int nMailCnt );
		bool ExitPop3( void );

		void EraseMailData( void );
		array<MailDataCage^>				^m_arMailDatas;
		System::Net::Sockets::Socket^		m_s;

	private:
		System::Net::Sockets::Socket^		CreateMailReadSocket( void );

		// Pop3Rcv.cpp

		bool FormatMailDataCages( array<MailDataCage^> ^%arMail );

		int RcvDataInPop3( array<Byte>	^%byarRcv, int nTimeOut, bool blDotEnd );

		int RcvDataInPop3MainData( int nSize, array<Byte>	^%byarRcv, int nTimeOut );

		bool RcvRawMailInPop3( int nMaxMsgNo );

		String^								GetUserNameFromIni( void );
		String^								GetPasswordFromIni( void );
	};
};

