#include "stdafx.h"
#include "MHttpTray.h"

#include "..\etc\LogPlus.h"
#include "..\etc\IoIni.h"
#include "..\Mail\MailManage.h"


#include "..\ThrMHttp.h"
#include "..\SvcNameDef.h"


nsSvcMHttp::MHttpTray::MHttpTray()
{

	return;
}

nsSvcMHttp::MHttpTray::~MHttpTray()
{
	return;
}




void nsSvcMHttp::MHttpTray::StartMHttpTray()
{

	m_strIp = nullptr;

	m_pLogP = gcnew LogP();


	System::Reflection::Assembly	^pAsembly
		= System::Reflection::Assembly::GetEntryAssembly();
	delete pAsembly;

	String ^strIconPath = System::IO::Path::GetDirectoryName( pAsembly->Location ) + 
				"\\MHttp.ico";


	// m_pLogP->LogWithDate( "SystemTray: 쐬Jn" );
	//m_frmSysTray = gcnew System::Windows::Forms::Form();
	try {
		
		m_ntcIcon    = gcnew System::Windows::Forms::NotifyIcon();


		//System::IO::Stream ^pSt =
		//pAssembly->GetManifestResourceStream("MHttp.5");

		System::Drawing::Icon  ^pIcon;
		
		pIcon = gcnew System::Drawing::Icon ( strIconPath );


		m_ntcIcon->Icon = pIcon;

		

	} catch ( System::Exception ^e ) {



		delete e;
		delete strIconPath;
		return;
	}

	delete strIconPath;


	System::Windows::Forms::ContextMenu		^pCMenu
		= gcnew System::Windows::Forms::ContextMenu();

	System::Windows::Forms::MenuItem		^pMenuItemStop
		= gcnew System::Windows::Forms::MenuItem();
	pMenuItemStop->Text = "~";
	pMenuItemStop->Click += gcnew System::EventHandler(this, &nsSvcMHttp::MHttpTray::ClickStop );

	pCMenu->MenuItems->Add( 0, pMenuItemStop );


	System::Windows::Forms::MenuItem		^pMenuItemLog
		= gcnew System::Windows::Forms::MenuItem();
	pMenuItemLog->Text = "ŐVO\";
	pMenuItemLog->Click += gcnew System::EventHandler(this, &nsSvcMHttp::MHttpTray::ClickLog );

	pCMenu->MenuItems->Add( 0, pMenuItemLog );




	System::Windows::Forms::MenuItem		^pMenuItemSetup
		= gcnew System::Windows::Forms::MenuItem();
	pMenuItemSetup->Text = "ݒ";
	pMenuItemSetup->Click += gcnew System::EventHandler(this, &nsSvcMHttp::MHttpTray::ClickSetup );

	pCMenu->MenuItems->Add( 0, pMenuItemSetup );



	m_ntcIcon->ContextMenu = pCMenu;

	m_ntcIcon->Visible = true;
	
	m_ntcIcon->Text = "MiniHttp";
	

	m_ntcIcon->BalloonTipIcon = System::Windows::Forms::ToolTipIcon();
	m_ntcIcon->BalloonTipTitle = "\0";
	

	//m_frmSysTray->Controls->Add( dynamic_cast<Control^> (m_ntcIcon)   );

	m_ntcIcon->BalloonTipClicked += 
		gcnew System::EventHandler(this, &nsSvcMHttp::MHttpTray::ToolTipClicked   );
	m_ntcIcon->MouseDoubleClick += 
		gcnew System::Windows::Forms::MouseEventHandler(this, &nsSvcMHttp::MHttpTray::MouseDoubleClick );

	//m_frmSysTray->Show( nullptr );



	m_dteLastDisp = System::DateTime::MinValue;
	m_dteLastIpRefresh = m_dteLastDisp;

	return;
}


void nsSvcMHttp::MHttpTray::ExitMHttpTray()
{
	//m_frmSysTray->Close();
	//delete  m_frmSysTray;



	/* j[\[XJB */
	/* PC Vbg_E Explorer Ǐ */
	/* ӂɂ̂ł́H '10.2.27 */
	System::Windows::Forms::ContextMenu		^pCMenu;
	pCMenu = m_ntcIcon->ContextMenu;

	pCMenu->MenuItems->Clear();

	m_ntcIcon->ContextMenu = nullptr;
	delete pCMenu;
	pCMenu = nullptr;

	delete  m_ntcIcon;

	//m_frmSysTray = nullptr;
	m_ntcIcon    = nullptr;





	if ( m_strIp != nullptr ) {
		delete m_strIp;
		m_strIp = nullptr;
	}
	delete m_pLogP;
	m_pLogP = nullptr;

	return;
}

void nsSvcMHttp::MHttpTray::ReactSession()
{

	System::Windows::Forms::Application::DoEvents();



	if ( m_dteLastDisp < System::DateTime::Now ) {
		m_dteLastDisp = System::DateTime::Now.AddSeconds( 20 );
		m_ntcIcon->BalloonTipText = nullptr;
	}



	if ( m_dteLastIpRefresh < System::DateTime::Now ) {

		/* ̏͏dĎgɂȂȂcH */
		m_strIp = MailReactor::GetSvrIp();



		/* 擾 IP ۑ */
		IniInfo		^pIniInfo
			= gcnew IniInfo();
			pIniInfo->WriteIni(
			IniInfo::KeyTable::STR_SYSLOGD_FIRSTPPPIP, 
					m_strIp );
		delete pIniInfo;

		m_ntcIcon->Text = "MiniHttp\n" + 
			m_strIp;



		m_dteLastIpRefresh = System::DateTime::Now.AddSeconds( 60 );

	}


	return;
}



void nsSvcMHttp::MHttpTray::AddMessage( System::String ^strMsg )
{
	if ( m_ntcIcon == nullptr ) {
		return;
	}

	String ^strCurMsg;

	m_dteLastDisp = System::DateTime::Now.AddSeconds( 20 );

	strCurMsg = String::Concat( m_ntcIcon->BalloonTipText, "\n", strMsg );
	m_ntcIcon->BalloonTipText = strCurMsg;
	delete strCurMsg;


	m_ntcIcon->ShowBalloonTip( 10000 );


}




System::Void nsSvcMHttp::MHttpTray::ToolTipClicked(System::Object^  sender, System::EventArgs^  e)
{
	/* Ot@CJ */
	//System::Windows::Forms::MessageBox::Show( "AAA" );


#if 0

	System::Reflection::Assembly	^myAssembly
		= System::Reflection::Assembly::GetEntryAssembly();
	String	^strPath = myAssembly->Location;

	strPath = strPath->Substring( 0, strPath->LastIndexOf( "\\" ) +1 );
	strPath = String::Concat( strPath, strLogFileName );
#endif

}




System::Void nsSvcMHttp::MHttpTray::MouseDoubleClick(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) 
{
	String		^strLogFile = nullptr;
	/* Ot@C̃eLXgJ */
	strLogFile = m_pLogP->GetCurrentLogFileName();

	System::Diagnostics::Process::Start( strLogFile );

}



System::Void nsSvcMHttp::MHttpTray::ClickSetup( System::Object^  sender, System::EventArgs^  e)
{

	/* g exe Ăяo */


	System::Reflection::Assembly		^pAssembly
		= System::Reflection::Assembly::GetExecutingAssembly();

	
	System::Diagnostics::Process::Start( pAssembly->Location );

	return;
}

System::Void nsSvcMHttp::MHttpTray::ClickLog( System::Object^  sender, System::EventArgs^  e)
{
	MouseDoubleClick( nullptr, nullptr );
	return;
}



System::Void nsSvcMHttp::MHttpTray::ClickStop( System::Object^  sender, System::EventArgs^  e)
{
	//nsSvcMHttp::ThrMHttp::StopThreadFromInternal();

	System::ServiceProcess::ServiceController	^pCont;

	try {
		pCont = gcnew System::ServiceProcess::ServiceController( SVCNAMEDEF_SERVICEDESCRIPTION );
		if ( pCont->ServiceName == "" ) {
			delete pCont;
			throw gcnew System::Exception();
		}
		if ( pCont->Status == System::ServiceProcess::ServiceControllerStatus::Running ) {
			pCont->Stop();
		}
	} catch ( System::Exception ^e ) {
		delete pCont;
		delete e;
		return;
	}
	delete pCont;

	return;
}







System::String^ nsSvcMHttp::MHttpTray::GetCurrentIpStr( void ) {
	return m_strIp;
}

