#pragma once

#include "..\etc\LogPlus.h"


namespace nsSvcMHttp
{
	using namespace System;


	public ref class HttpRequestData_Upload
	{
	public:

		HttpRequestData_Upload()
		{
			m_strFileName = nullptr;
			m_strAttr = nullptr;
			m_byarFileData = nullptr;
		}

		~HttpRequestData_Upload()
		{
			delete m_strFileName;
			delete m_strAttr;
			delete m_byarFileData;
		}

		String		^m_strFileName;
		String		^m_strAttr;
		array<Byte>	^m_byarFileData;
	};


	public ref class HttpRequestData
	{
	public:
		HttpRequestData();
		~HttpRequestData();
		int			RequestType;
		static const int	REQUESTType_GET  = 1;	/* t@C擾 */
		static const int	REQUESTType_POST = 2;	/* {^ꂽ */
		static const int	REQUESTType_CGI  = 3;	/* cgi s */

		String							^GET_FileName;			/* GET ̃t@C */
		System::Collections::SortedList	^POST_srtData;			/* POST ̑ */
		String							^CGI_Arg;				/* CGI ̈ */
		
		int			UserAppType;
		static const int	USERAPPTYPE_PC		= 1;	/* PC ANZX */
		static const int	USERAPPTYPE_DOCOMO  = 2;	/* gтANZX */
		static const int	USERAPPTYPE_ELSE    = 3;	/* gтANZX */
		

		String		^ClientIp;				/* NCAg IP AhX */
		int 		^ClientPort;			/* NCAg |[gԍ */

		System::Collections::SortedList		^m_srtAttr;
		System::Net::Sockets::Socket		^m_s;
		DateTime							m_dteLastConnection;

		array<Byte>							^m_byarRcv;
		array<Byte>							^m_byarContents;

		array<HttpRequestData_Upload^>		^m_arUpLoadDatas;

		bool IsNotKeepAlive( void );



		/* FOMA ΍FRecĂ̂ */
		/* ُɒxߎMf[^Ď */
		bool IsContentsRecieved( void );

		bool IsContentsWaiting( void );

		bool IsContentsTimeOut( void );
		void SetTimerContentsRcv( void );
		void DelTimerContentsRcv( void );

		void AddRcieveBuff( array<Byte>	^%byarNewRcv );

		void ClearUsedData( bool blRcvBufClear );

	private:
		DateTime		m_dteRcvLast;	

	};


	public ref class ReadHttpSession
	{
	public:
		ReadHttpSession();
		~ReadHttpSession();

		bool ParseActionData( array<Byte> ^byarRcv, 
								String ^strRemoteIp,
								int    iRemotePort, 
								HttpRequestData ^%pHttpReq
								);
	};




	

	public ref class MakeHttpRetData
	{

	public:
		MakeHttpRetData();
		~MakeHttpRetData();

		bool	ExeAndMakeRetData( 
			nsSvcMHttp::HttpRequestData		^HttpRcvInf, 			
			array<Byte> ^%byarSend );

		void	OutputLog( 
			nsSvcMHttp::HttpRequestData		^HttpRcvInf );


	private:
		String	^m_strHttpDir;
		String	^m_strHttp_DefaultFile;

		LogP	^m_pLogP;

	};






};