
#include "stdafx.h"

#include "..\..\etc\Secures.h"
#include "hSecure.h"
#include "..\..\etc\IoIni.h"



nsSvcMHttp::httpSecure::httpSecure()
{
	//IpSecure::IpSecure();
}

nsSvcMHttp::httpSecure::~httpSecure()
{
	//IpSecure::~IpSecure();
}

bool nsSvcMHttp::httpSecure::RetHttpPermit( System::Net::IPAddress^ ipAddress )
{


	array<Byte> ^byarIp = ipAddress->GetAddressBytes();

	bool	blRet = false;
	int		nHit = -1;
	int		nIpMode = -1;

	/* IP AhXŌ */
	for ( int nCnt = 0 ; nCnt < m_arIpSecInfs->Count; nCnt++ ) {
		
		IpSecureInf ^pIpS
			= static_cast<IpSecureInf^>( m_arIpSecInfs[ nCnt ] );
		if ( pIpS->IsHitIp( byarIp ) == true ) {
			nHit = nCnt;
			nIpMode = pIpS->m_nPermitMode;
			break;
		}
	}
	delete byarIp;

	if ( nHit != -1 ) {

		switch( nIpMode )
		{
		case m_nMODE_Permit:
			blRet = true;
			break;
		default:
		case m_nMODE_Deny:
			blRet = false;
			break;

		case m_nMODE_None:
			/* ftHgIvVƂ͋t܂ɑI */
			switch( m_nMode )
			{
			case m_nMODE_Permit:
				blRet = false;
				break;
			default:
			case m_nMODE_Deny:
				blRet = true;
				break;
			}
			break;
		}

		return blRet;
	}














	/* DNS Ō */
	bool		blDns = false;
	System::Net::IPHostEntry	^iphostent;

	try {
		iphostent = System::Net::Dns::GetHostEntry( ipAddress );
		blDns = true;
	} catch ( Exception ^e ) {
		/* DNS ݂͑Ȃ̂ŏI */
		delete e;
	}

	if ( blDns ) {
	
		int			nHitIpSecNo = -1;
		int			nMode;
		
		for ( int nCnt = 0; nCnt < m_arIpSecInfs->Count ; nCnt++ ) {
			
			IpSecureInf ^pISInf
				= static_cast<IpSecureInf^>
					( m_arIpSecInfs[ nCnt ] );
			
			bool blHit = pISInf->IsHitDomain( iphostent->HostName );
			if ( blHit == true ) {
				nHitIpSecNo = nCnt;
				nMode = pISInf->m_nPermitMode;
				break;
			}
		}

		delete iphostent;

		if (  nHitIpSecNo != -1 ) {

			switch( nMode ) {
			case m_nMODE_None:
				switch( m_nMode ) {
				case m_nMODE_Permit:
					blRet = false;
					break;
				case m_nMODE_Deny:
					blRet = true;
					break;
				}
				break;

			case m_nMODE_Permit:
				blRet = true;
				break;

			case m_nMODE_Deny:
				blRet = false;
				break;
			}
			return blRet;

		}


	}







	/* IP/hCqbgȂꍇ */
	switch( m_nMode ) {
	case m_nMODE_None:
	case m_nMODE_Permit:
		blRet = true;
		break;
	default:
	case m_nMODE_Deny:
		blRet = false;
		break;
	}
	return blRet;



}


System::String ^nsSvcMHttp::httpSecure::GetIni_SecName( void )
{

	String ^strModeIni = gcnew String( "" );
	IniInfo		^pIniInfo = gcnew IniInfo();
	pIniInfo->ReadIni( 
		IniInfo::KeyTable::STR_HTTPFILE_ACCEPT_MODE, 
		strModeIni );

	delete pIniInfo;

	return strModeIni;
}




System::String ^nsSvcMHttp::httpSecure::GetIni_KeyName( void )
{
	String ^strDomains = gcnew String( "" );
	IniInfo		^pIniInfo = gcnew IniInfo();
	pIniInfo->ReadIni( 
		IniInfo::KeyTable::STR_HTTPFILE_ACCEPT_DOMAIN, 
		strDomains );
	delete pIniInfo;

	return strDomains;

}

