#pragma once


namespace nsSvcMHttp {

	using namespace		System;

	ref class IPGetBrowse
	{

	public:
		IPGetBrowse(void);
		~IPGetBrowse(void);

		bool		StartBrowse( void );
		void		ReactSession( void );
		void		ExitBrowse( void ) { return; };

		static String	^m_strIpStr;

		/* MailManage.cpp : MailReactor::ReactSession */
		/* ւ̃C^[tFCX֐ */
		/* NɐȂ IP n̂h */
		static bool		UseFirstPrs300( void );
		static bool		IpGot( void );

		enum class enmError {
			NONE,
			CONNECT_FAILED,
			SEND_GET_TOP_WAIT_SENDTIMEOUT,
			RCV__GET_TOP_WAIT_RCVTIMEOUT,
			RECONNECT_FAILED,
			SEND_GET_BASE64URL_WAIT_SNDTIMEOUT,
			RCV__GET_BASE64URL_HEADER_WAIT_RCVTIMEOUT,
			RCV__GET_BASE64URL_HEADER_WAIT_NO_CONTENTS_LENGTH,
			RCV__GET_BASE64URL_HEADER_WAIT_BAD_CONTENTS_LENGTH,
			RCV__GET_BASE64URL_CONTENTS_WAIT_RCVTIMEOUT
		};

	private:

		enum class enmStatus {
			POLL_WAITSTART,
			POLL_WAIT,
			CONNECT,
			SEND_GET_TOP,
			SEND_GET_TOP_WAIT,
			RCV__GET_TOP_WAIT,
			RECONNECT,
			SEND_GET_BASE64URL,
			SEND_GET_BASE64URL_WAIT,
			RCV__GET_BASE64URL_HEADER_WAIT,
			RCV__GET_BASE64URL_CONTENTS_WAIT
		};

		static bool		m_blFirstUsePrc300;


		System::Net::Sockets::Socket^		
						CreateSocket( String ^strHostName );
		void			CloseSocket(void );

		enmStatus		ExeStStartWaitSet( void );
		enmStatus		ExeStStartWait( void );
		enmStatus		ExeStConnect( void );
		enmStatus		ExeStSendFirst( void );

		enmStatus		ExeStReConnect( void );
		
		enmStatus		ExeStSendBase64Url( void );
		enmStatus		ExeStRcvBase64UrlHeader( void );
		
		enmStatus		ExeStRcvBase64UrlContents( void );



		bool			IsUsePrs300( void );


		enmStatus							m_nState;
		enmError							m_nError;

		DateTime							m_dteKickTime;

		System::Net::Sockets::Socket^		m_s;




		array<Byte>		^m_byarRcv;	
		array<Byte>		^m_byarSnd;


		


		ref class Sender
		{
		public:
			Sender( void );
			~Sender( void );

			bool TrySend( array<Byte> ^%byarData );
			
			bool TryRcv( int nSize );
			bool TryRcvAppendFull( int nAddSize );
			void TryRcvMore( void );


			bool IsSent( void );
			bool IsSendErr( void );

			bool IsRcved( array<Byte> ^%byarRcv );
			bool IsRcvErr( void );


			property int RcvCnt {
				int get();
				void set( int nSize );
			}

			property int RcvBufSize {
				int get();
			}


			bool RcvBufFullMode( void );
			void RcvBufFullMode( bool blMode );


			/* IAsync pC^[tFCX */
			void SetRcved( bool blError );

			void SendCompleteEvent( System::Object^  sender, System::Net::Sockets::SocketAsyncEventArgs^  e);
			//void RcvCompleteEvent( System::Object^  sender, System::Net::Sockets::SocketAsyncEventArgs^  e);
			static void RcvCompleteEvent( System::IAsyncResult ^result);


			
			void							SetSocket( System::Net::Sockets::Socket ^%socket );
			/* IAsync pC^[tFCX */
			System::Net::Sockets::Socket^%	GetSocket( void );




		private:
		
			enum class enmSendStatus {
				NONE,
				SENDING,
				SENDED,
				SEND_ERR
			};


			enum class enmRcvStatus {
				NONE,
				RCVING,
				RCVED,
				RCV_ERR
			};


			System::Net::Sockets::Socket
								^m_scKocket;
			System::Net::Sockets::SocketAsyncEventArgs^
								m_evSend;
			System::Net::Sockets::SocketAsyncEventArgs^
								m_evRcv;
			System::AsyncCallback	^m_dltRcvCallBack;

			enmSendStatus		m_nSendState;
			enmRcvStatus		m_nRcvState;

			array<Byte>			^m_byarSendData;
			array<Byte>			^m_byarRcvData;

			bool				m_blRcvFullMode;
			long				m_nRcvCount;
			
			DateTime			m_dteSndTimeOut;
			DateTime			m_dteRcvTimeOut;
		};


		Sender								^m_objSender;

	};


}
