
#include "stdafx.h"
#include "..\etc\Nv3GetIp.h"

#include "..\etc\LogPlus.h"


using namespace System;
using namespace System::Net;
using namespace System::Net::Sockets;

using namespace nsSvcMHttp;


nsSvcMHttp::Nv3ModemGetIp::Nv3ModemGetIp()
{
	m_byarRcv = gcnew array<Byte>( 300 );
	m_byarSnd = gcnew array<Byte>( 100 );
	m_socket = nullptr;

}

nsSvcMHttp::Nv3ModemGetIp::~Nv3ModemGetIp()
{
	if ( m_byarRcv != nullptr ) {
		delete m_byarRcv;
	}
	m_byarRcv = nullptr;

	if ( m_byarSnd != nullptr ) {
		delete m_byarSnd;
	}
	m_byarSnd = nullptr;

	Close();


}



String^ nsSvcMHttp::Nv3ModemGetIp::GetIp( String ^strModemIp, String ^strUserName, String ^strPassword )
{

	String	^strRet = nullptr;

	m_socket = CreateSocket( strModemIp );
	if ( m_socket == nullptr ) {
		return strRet;
	}




	/* MFlogin : */
	if ( Rcv( 61 ) == false ) {
		Close();
		return strRet;
	}

	String ^strRcv = System::Text::Encoding::ASCII->GetString( m_byarRcv );
	if ( strRcv->Substring( strRcv->Length - 10 ) != "login   : " ) {
		delete strRcv;
		Close();
		return strRet;
	}
	delete strRcv;

	
	/* MF[U[ */
	delete m_byarSnd;
	m_byarSnd = System::Text::Encoding::ASCII->GetBytes( strUserName + "\r\n" );
	if( Send() == false ) {
		Close();
		return strRet;
	}



	/* MFPassword: */
	if ( Rcv( 9 ) == false ) {
		Close();
		return strRet;
	}
	strRcv = System::Text::Encoding::ASCII->GetString( m_byarRcv );
	if ( strRcv->Substring( strRcv->Length-10,  10) != "Password: " ) {
		delete strRcv;
		Close();
		return strRet;
	}
	delete strRcv;



	/* MFpX[h */
	delete m_byarSnd;
	m_byarSnd = System::Text::Encoding::ASCII->GetBytes( strPassword  + "\r\n" );
	if( Send() == false ) {
		Close();
		return strRet;
	}


	/* MF                                      2 */
	/*       ### Welcome To ADSL MODEM NV3 ###    33 */
	/*                                             2 */
	/*       >                                     1 */
	if ( Rcv( 41 ) == false ) {
		Close();
		return strRet;
	}
	strRcv = System::Text::Encoding::ASCII->GetString( m_byarRcv );
	if ( strRcv->IndexOf( "\r\n### Welcome To ADSL MODEM NV3 ###") < 0 ) {
		delete strRcv;
		Close();
		return strRet;
	}



	if ( strRcv->IndexOf( ">" ) < 0 ) {
		delete strRcv;
		Close();
		return strRet;
	}
	delete strRcv;






	/* MFshow info wan 22 */
	delete m_byarSnd;
	m_byarSnd = System::Text::Encoding::ASCII->GetBytes( 
		"show info wan 22\r\n" );
	if( Send() == false ) {
		Close();
		return strRet;
	}







	/* MF                                   */
	/*       ### Welcome To ADSL MODEM NV3 ###  */
	/*                                          */
	/*       >                                  */
	if ( Rcv( 320 ) == false ) {
		Close();
		return strRet;
	}
	String ^strDiff = gcnew String( "IP ADDRESS       ..... " );
	strRcv = System::Text::Encoding::ASCII->GetString( m_byarRcv );
	int Pos;
	Pos = strRcv->IndexOf( strDiff );
	if ( Pos < 0 ) {
		delete strRcv;
		delete strDiff;
		Close();
		return strRet;
	}
	Pos += 23;
	





	

	/* byte ^z񂩂w蕶邩 */
	int nIpAddrPos;
	bool blFind = false;
	array<Byte> ^byarDiff = System::Text::Encoding::ASCII->GetBytes( strDiff );
	delete strDiff;

	for( nIpAddrPos = 0 ; nIpAddrPos < m_byarRcv->Length - byarDiff->Length ; nIpAddrPos++ ) {
		
		int nPosDiff;
		for ( nPosDiff = 0 ; nPosDiff < byarDiff->Length	; nPosDiff++ ) {
			if ( byarDiff[ nPosDiff] != 
				 m_byarRcv[ nIpAddrPos + nPosDiff ] ) {
				break;
			}
		}

		if ( nPosDiff >= byarDiff->Length ) {
			blFind = true;
			break;
		}
	}
	nIpAddrPos += byarDiff->Length;

	delete byarDiff;
	delete strRcv;
	if ( blFind == false ) {
		return strRet;
	}
	


	int PosDot = Pos;
	bool blErr = false;

	System::Text::StringBuilder ^stbIp = gcnew System::Text::StringBuilder();
	for ( int nCnt = 0; nCnt< 4 ; nCnt++ ) {

		Byte byBuf;

		byBuf = m_byarRcv[ nIpAddrPos + nCnt * 4 ];
		if ( byBuf != ' ' &&
			 byBuf != '0' && 
			 byBuf != '1' && 
			 byBuf != '2' ) {
			blErr = true;
			break;
		}

		if ( byBuf == '1' || byBuf == '2' ) {
			stbIp->Append( byBuf - '0' );
		}
		

		byBuf = m_byarRcv[ nIpAddrPos + nCnt * 4 + 1 ];
		if ( byBuf != ' ' && (byBuf < '0' || byBuf > '9') ) {
			blErr = true;
			break;
		}
		if ( byBuf >= '0' && byBuf <= '9' ) {
			stbIp->Append( byBuf - '0'  );
		}


		byBuf = m_byarRcv[ nIpAddrPos + nCnt * 4 + 2 ];
		if ( byBuf < '0' || byBuf > '9' ) {
			blErr = true;
			break;
		}
		stbIp->Append( byBuf - '0'  );


		if ( nCnt != 3 ) {
			byBuf = m_byarRcv[ nIpAddrPos + nCnt * 4 + 3 ];
			if ( byBuf != '.' ) {
				blErr = true;
				break;
			}
			stbIp->Append( "." );
		}
	}



	if ( blErr == false ) {
		strRet = stbIp->ToString();
	}
	delete stbIp;






	/* MFexit                               */
	delete m_byarSnd;
	m_byarSnd = System::Text::Encoding::ASCII->GetBytes( 
		"exit\r\n" );
	Send();
	Close();



	return strRet;
}



bool nsSvcMHttp::Nv3ModemGetIp::Rcv( int nRcv )
{
	bool blRet = false;

	if ( m_byarRcv == nullptr ) 
		m_byarRcv = gcnew array<Byte>( 0 );

	array<Byte>::Resize( m_byarRcv, 0 );


	int nRcvNow = 0;

	System::DateTime TimeOut = System::DateTime::Now.AddMilliseconds( 300 );

	//while ( System::DateTime::Now < TimeOut && nRcvNow < nRcv ) {
	while ( System::DateTime::Now < TimeOut && nRcvNow < nRcv ) {

		int nRcvTmp;
		array<Byte> ^byarRcvTmp;
		try {

				byarRcvTmp = gcnew array<Byte>( 100 );

			nRcvTmp = m_socket->Receive( 
				byarRcvTmp, byarRcvTmp->Length, static_cast<SocketFlags>(0) );


		} catch ( System::Net::Sockets::SocketException ^se ) {

			delete byarRcvTmp;
			/* ^CAEgG[̏ꍇ͑s */
			if ( se->SocketErrorCode == System::Net::Sockets::SocketError::TimedOut ) {
				delete se;
				continue;
			}

			delete se;
			return blRet;

		} catch ( System::Exception ^e ) {
			delete e;
			delete byarRcvTmp;
			return blRet;
		}


		if ( nRcvTmp <= 0 ) {
			continue;
		}
		TimeOut = System::DateTime::Now.AddMilliseconds( 300 );

		array<Byte>::Resize( m_byarRcv, nRcvNow+nRcvTmp );
		array<Byte>::Copy( byarRcvTmp, 0, 
						   m_byarRcv, nRcvNow, nRcvTmp );
		nRcvNow += nRcvTmp;
		
		delete byarRcvTmp;

	}


	if ( m_byarRcv->Length >= nRcv ) {
		blRet = true;
	}


	return blRet;
}


bool nsSvcMHttp::Nv3ModemGetIp::Send( void )
{

	bool blRet = false;
	int nSnd;

	try {
		nSnd = m_socket->Send( m_byarSnd, m_byarSnd->Length, static_cast<SocketFlags>(0) );
	} catch ( System::Exception ^e ) {
		delete e;
		return blRet;
	}

	if ( nSnd != m_byarSnd->Length ) {

		while ( nSnd < m_byarSnd->Length ) {

			array<Byte> ^byarSnd = gcnew array<Byte>( m_byarSnd->Length - nSnd );
			array<Byte>::Copy( m_byarSnd, nSnd, 
							byarSnd, 0, m_byarSnd->Length - nSnd );
			

			int nSndTmp;
			
			try { 
				nSndTmp = m_socket->Send( byarSnd, byarSnd->Length, static_cast<SocketFlags>(0) );
			} catch ( System::Exception ^e ) {
				delete e;
				delete byarSnd;
				return blRet;
			}
			delete byarSnd;

			nSnd += nSndTmp;
		}

	}



	blRet = true;
	return blRet;
}



void nsSvcMHttp::Nv3ModemGetIp::Close( void )
{
	if ( m_socket == nullptr ) {
		return;
	}

	try {
		m_socket->Close();

		
	} catch ( System::Exception ^e ) {
		delete e;
	}
	delete m_socket;

	m_socket = nullptr;

}


Socket^ nsSvcMHttp::Nv3ModemGetIp::CreateSocket( String ^strIp )
{
	Socket		^s_ret = nullptr;
	String		^strHostString = strIp;
	Int32		^int32Port = 23;

	
	IPHostEntry^ hostEntry = nullptr;

	try {
		System::Net::IPAddress ^ipaddr_rtr;
		if ( System::Net::IPAddress::TryParse( strIp, ipaddr_rtr ) == false ) {
			/* IP AhX\Lł͂ȂB */
			hostEntry = Dns::GetHostEntry( strIp );
		} else {

			/* samba ɓo^ĂȂ IP AhX */
			/* Dns::GetHostEntry sB */
			/* ȉR[hɂ蒼 IP wɂ */
			/* hostEntry 쐬\ɂ */

			ipaddr_rtr = System::Net::IPAddress::Parse( strIp );

			array<System::Net::IPAddress^>  ^iplist = 
				gcnew array<System::Net::IPAddress^>( 1 );

			iplist[ 0 ] = ipaddr_rtr;


			hostEntry = gcnew System::Net::IPHostEntry();
			hostEntry->AddressList = iplist;

		}
		
		
	} catch( System::Exception ^e ) {
		delete e;
		return nullptr;
	}

	System::Collections::IEnumerator^ myEnum = hostEntry->AddressList->GetEnumerator();
	while ( myEnum->MoveNext() )
	{
		IPAddress^ address = safe_cast<IPAddress^>(myEnum->Current);
		IPEndPoint^ endPoint = gcnew IPEndPoint( address, (int)int32Port );
		Socket^ tmpS = gcnew Socket( endPoint->AddressFamily,SocketType::Stream,ProtocolType::Tcp );

		try {
			tmpS->Connect( endPoint );


		} catch ( Exception^ e ) {
			if ( e == e )
				e = e; 

			delete int32Port;

			delete address;
			delete endPoint;
			delete tmpS;
			return s_ret;

		}

		if ( tmpS->Connected )
		{
			/* zXgA|[g\Pbg擾 */
			s_ret = tmpS;
			break;
		} else {
		 continue;
		}
	}

	if ( s_ret == nullptr ) {
		/* \Pbg̐ڑs */

		delete strHostString;
		delete int32Port;

		return s_ret;
	}

	int		nTimeOut = 500;
	s_ret->ReceiveTimeout = nTimeOut;



	delete int32Port;

	return s_ret;
}











void nsSvcMHttp::Nv3ModemGetIp::DebugOut( String ^strLog )
{
	LogP	^pLog = gcnew LogP();

	pLog->LogWithDate( " Nv3GetIP : " + strLog );
	delete pLog;

}