#include "stdafx.h"

#include "Secures.h"

#include "..\etc\IoIni.h"




nsSvcMHttp::IpSecureInf::IpSecureInf( void )
{
	m_byarIp = nullptr;
	m_byarIpMask = nullptr;

	m_strDomain = nullptr;
}

nsSvcMHttp::IpSecureInf::~IpSecureInf( void )
{
	if ( m_byarIp != nullptr ) {
		delete m_byarIp;
		m_byarIp = nullptr;
	}

	if ( m_byarIpMask != nullptr ) {
		delete m_byarIpMask;
		m_byarIpMask = nullptr;
	}

	if ( m_strDomain != nullptr ) {
		delete m_strDomain;
		m_strDomain = nullptr;
	}
	

}


void nsSvcMHttp::IpSecureInf::SetIpOrDomain( System::String ^strIpStr )
{

	bool	blIp = true;

	System::Collections::ArrayList	^byalIp
		= gcnew System::Collections::ArrayList();

	array<Byte>		^byarIpStr =
		System::Text::Encoding::ASCII->GetBytes( strIpStr->ToLower() );

	/* IP AhXȂ IP 擾 */

	int nPos = 0;
	int nPosOld = 0;
	Byte byIp;
	int nOrder = 0;
	int nNetMask = -1;

	byIp = 0;
	while ( nPos < byarIpStr->Length ) {
		
		if (  byarIpStr[ nPos ] >= '0' &&
			  byarIpStr[ nPos ] <= '9'      ) {

			if ( nOrder >= 3 ) {
				/* 4 ȏ IP oAu[N */
				blIp = false;
				break;
			}
	
			byIp *= 10;
			byIp += byarIpStr[ nPos ] - '0';

			nOrder++;

		} else if ( byarIpStr[ nPos ] == '.' ) {
			byalIp->Add( byIp );
			byIp = 0;
			nOrder = 0;

		} else if ( byarIpStr[ nPos ] == '/' ) {

			/* Tulbgǂݎ */
			if ( nNetMask >= 0 ) {
				/* G[ATulbg\LQ */
				blIp = false;
				break;
			}

			nNetMask = 0;
			int nOrderNetMask = 0;
			nPos++;
			while ( nPos < byarIpStr->Length ) {
				if ( byarIpStr[ nPos ] >= '0' &&
					byarIpStr[ nPos ] <= '9' ) {

					if ( nOrderNetMask>=3 ) {
						blIp = false;
						break;
					}

					nNetMask *= 10;
					nNetMask += byarIpStr[ nPos ] - '0';
					nOrderNetMask++;
				}
				nPos++;

			}


			if ( blIp == false ) {
				break;
			}


		} else {
			/* FoȂAǂݎI */
			blIp = false;
			break;
		}
		nPos++;

	}

	if ( nOrder> 0 ) {
		byalIp->Add( byIp );
	}

	delete byalIp;
	delete byarIpStr;

	if ( blIp==false ) {
		/* IP ͑hC\L */
		if ( m_strDomain != nullptr )
			delete m_strDomain;
		m_strDomain = gcnew String( strIpStr );
		return;
	}

	if ( m_byarIp != nullptr ) 
		delete m_byarIp;
	m_byarIp = static_cast<array<Byte>^>
	( byalIp->ToArray( Byte::typeid )  );


	if ( nNetMask == -1 ) {
		nNetMask = 32;
	}



	int		nLastByte, nLastByteBit;
	m_byarIpMask = gcnew array<Byte>( 4 );
	if ( nNetMask >= 24 ) {
		/* ff.ff.ff.xx */
		m_byarIpMask[ 0 ] = 0xff;
		m_byarIpMask[ 1 ] = 0xff;
		m_byarIpMask[ 2 ] = 0xff;

		unsigned int nBuf;
		nBuf = 0x100;
		
		nLastByte = 3;
		nLastByteBit = nNetMask - 24;

	}
	else if ( nNetMask >= 16 ) {
		/* ff.ff.xx.xx */
		m_byarIpMask[ 0 ] = 0xff;
		m_byarIpMask[ 1 ] = 0xff;

		m_byarIpMask[ 3 ] = 0x00;

		nLastByte = 2;
		nLastByteBit = nNetMask - 16;

	}
	else if ( nNetMask >= 8 ) {
		/* ff.xx.xx.xx */
		m_byarIpMask[ 0 ] = 0xff;

		m_byarIpMask[ 2 ] = 0x00;
		m_byarIpMask[ 3 ] = 0x00;

		nLastByte = 1;
		nLastByteBit = nNetMask - 8;
	} else {
		/* xx.xx.xx.xx */
		m_byarIpMask[ 1 ] = 0x00;
		m_byarIpMask[ 2 ] = 0x00;
		m_byarIpMask[ 3 ] = 0x00;

		nLastByte = 0;
		nLastByteBit = nNetMask;

	}

	Byte byBuf;
	switch( nLastByteBit ) {
	case 0:		byBuf =   0;	break;
	case 1:		byBuf = 0x80;	break;
	case 2:		byBuf = 0xc0;	break;
	case 3:		byBuf = 0xe0;	break;
	case 4:		byBuf = 0xf0;	break;
	case 5:		byBuf = 0xf8;	break;
	case 6:		byBuf = 0xfc;	break;
	case 7:		byBuf = 0xfe;	break;
	case 8:		byBuf = 0xff;	break;
	}

	m_byarIpMask[ nLastByte ] = byBuf;


}


bool nsSvcMHttp::IpSecureInf::IsHitDomain( System::String ^strChkStr )
{
	bool blRet = false;

	if ( m_strDomain == nullptr )
		return blRet;

	String ^strChkL    = strChkStr->ToLower();
	String ^strDomainL = m_strDomain->ToLower();

	if ( strChkL->IndexOf( strDomainL ) >= 0 )
		blRet = true;

	delete strChkL;
	delete strDomainL;

	return blRet;
}

bool nsSvcMHttp::IpSecureInf::IsHitIp( array<System::Byte>^	byarIp )
{
	bool blRet = false;

	if ( m_byarIp == nullptr ) {
		return blRet;
	}


	Byte byCmp;
	Byte byIpMasked;

	blRet = true;
	for( int nCnt = 0; nCnt < 4; nCnt++ ) {
		byCmp      = m_byarIp[ nCnt ] & m_byarIpMask[ nCnt ];
		byIpMasked = byarIp[ nCnt ]   & m_byarIpMask[ nCnt ];

		if ( byCmp != byIpMasked ) {
			blRet = false;
			break;
		}
	}

	return blRet;
}


bool nsSvcMHttp::IpSecureInf::IsHaveIp( void )
{
	if ( m_strDomain == nullptr && m_byarIp != nullptr ) 
		return true;
	return false;
}
bool nsSvcMHttp::IpSecureInf::IsHaveDomain( void )
{
	if ( m_strDomain != nullptr && m_byarIp == nullptr ) 
		return true;
	return false;
}

int nsSvcMHttp::IpSecureInf::RetNetMask( void )
{
	Byte	byarPartMask[ 9 ] = { 0x00, 0x80, 0xc0, 0xe0, 0xf0, 
								  0xf8, 0xfc, 0xfe, 0xff };


	int nRet = -1;
	if ( m_byarIpMask == nullptr ) 
		return nRet;

	int nPos;

	if ( m_byarIpMask[ 1 ] == 0x00 ) {
		nPos = 0;
	} else if ( m_byarIpMask[ 2 ] == 0x00 ) {
		nPos = 1;
	} else if ( m_byarIpMask[ 3 ] == 0x00 ) {
		nPos = 2;
	} else {
		nPos = 3;
	}


	// 00    0
	// 80    1
	// c0    2
	// e0    3
	// f0    4
	// f8    5
	// fc    6
	// fe    7
	// ff    8

	int nBitHit;
	for ( nBitHit = 0; nBitHit < 9; nBitHit++ ) {
		if ( m_byarIpMask[ nPos ] == byarPartMask[ nBitHit ] ) {
			break;
		}
	}

	nRet = nPos * 8 + nBitHit;
		

	return nRet;

}










nsSvcMHttp::IpSecure::IpSecure( void )
{
	m_arIpSecInfs = nullptr;
	m_nMode = m_nMODE_Permit;
}

nsSvcMHttp::IpSecure::~IpSecure( void )
{
	if ( m_arIpSecInfs != nullptr ) {
		delete m_arIpSecInfs;
		m_arIpSecInfs = nullptr;
	}
}


bool nsSvcMHttp::IpSecure::GetIni( void )
{
	bool		blRet = false;

	IniInfo		^pIniInf = gcnew IniInfo();


	String ^strModeIni = GetIni_SecName();
	m_nMode = RetMode( strModeIni );
	if ( m_nMode == -1 ) 
		m_nMode = m_nMODE_Deny;
	delete strModeIni;



	String ^strDomains = GetIni_KeyName();

	
	if ( m_arIpSecInfs != nullptr ) 
		delete m_arIpSecInfs;
	m_arIpSecInfs = gcnew System::Collections::ArrayList();

	

	strDomains = strDomains->ToLower();


	/* domain:(deny/permit);domain:(deny/permit);.... */
	int nPos = 0;
	int nPosOld = 0;

	int nModeTmp;

	nPos = strDomains->IndexOf( ":" );
	if ( strDomains->Length > 0 && nPos < 0 ) {
		nPos = strDomains->Length;
	}
	while ( nPos >= 0 ) {
		/* */
		String ^strDomain;
		String ^strDMode;

		strDomain = nullptr;
		strDMode  = nullptr;

		nModeTmp = m_nMode;
		switch( m_nMode ) {
		case m_nMODE_Permit:	nModeTmp = m_nMODE_Deny;	break;
		case m_nMODE_Deny:		nModeTmp = m_nMODE_Permit;	break;
		}

		strDomain = strDomains->Substring( nPosOld, (nPos-1)-nPosOld +1 );

		int nPosMode = strDomain->IndexOf( ";" );
		if ( nPosMode >= 0 ) {
			strDMode = strDomain->Substring( nPosMode+1 );
			strDomain = strDomain->Substring( 0, nPosMode );

			strDMode = strDMode->ToLower();
			nModeTmp = RetMode( strDMode );
			if ( nModeTmp == -1 ) {

				switch( m_nMode ) {
				case m_nMODE_Permit:	nModeTmp = m_nMODE_Deny;	break;
				case m_nMODE_Deny:		nModeTmp = m_nMODE_Permit;	break;
				}

			}
		}

		IpSecureInf		^pIpSecureInf;
		pIpSecureInf = gcnew IpSecureInf();

		/* IP AhX/TulbghCݒ */
		pIpSecureInf->SetIpOrDomain( strDomain );
		pIpSecureInf->m_nPermitMode = nModeTmp;

		m_arIpSecInfs->Add( pIpSecureInf );

		delete strDomain;
		delete strDMode;

		

		if ( nPos == strDomains->Length ) {
			blRet = true;
			break;
		}

		nPosOld = nPos+1;
		nPos = strDomains->IndexOf( ":", nPosOld );
		if ( nPos < 0 ) {
			nPos = strDomains->Length;
		}

	}



	delete strDomains;






	return blRet;
	
}


bool nsSvcMHttp::IpSecure::IsPermitDomain( System::String ^strChkStr )
{

	bool		blRet = false;

	bool blHit = false;

	int			nHitIpSecNo = -1;
	
	for ( int nCnt = 0; nCnt < m_arIpSecInfs->Count ; nCnt++ ) {
		
		IpSecureInf ^pISInf
			= static_cast<IpSecureInf^>
				( m_arIpSecInfs[ nCnt ] );
	
		
		blHit = pISInf->IsHitDomain( strChkStr );
		if ( blHit == true ) {
			nHitIpSecNo = nCnt;
			break;
		}

	}

	if (  blHit ) {
		IpSecureInf ^pISInf
			= static_cast<IpSecureInf^>
				( m_arIpSecInfs[ nHitIpSecNo ] );

		switch( pISInf->m_nPermitMode ) {
		case m_nMODE_None:
			switch( m_nMode ) {
			case m_nMODE_Permit:
				blRet = true;
				break;
			case m_nMODE_Deny:
			default:
				blRet = false;
				break;
			}
			break;

		case m_nMODE_Permit:
			blRet = true;
			break;

		case m_nMODE_Deny:
			blRet = false;
			break;

		}

	} else {

		switch( m_nMode ) {
		case m_nMODE_Permit:
			blRet = true;
			break;
		case m_nMODE_Deny:
		default:
			blRet = false;
			break;
		}

	}

	return blRet;
	
}



bool nsSvcMHttp::IpSecure::IsPermitIp( array<System::Byte>^ byarIp )
{
	bool	blRet = false;
	int		nHit = -1;

	for ( int nCnt = 0 ; nCnt < m_arIpSecInfs->Count; nCnt++ ) {
		
		IpSecureInf ^pIpS
			= static_cast<IpSecureInf^>( m_arIpSecInfs[ nCnt ] );
		if ( pIpS->IsHitIp( byarIp ) == true ) {
			nHit = nCnt;
			break;
		}
	}

	int nBuf;
	if ( nHit== -1 ) {
		nBuf = m_nMode;
	} else {
		IpSecureInf ^pIpS
			= static_cast<IpSecureInf^>( m_arIpSecInfs[ nHit ] );

		nBuf = pIpS->m_nPermitMode;
	}

	switch( nBuf )
	{
	case m_nMODE_Permit:
		blRet = true;
		break;
	default:
	case m_nMODE_None:
	case m_nMODE_Deny:
		blRet = false;
		break;
	}

	return blRet;
}




System::Collections::ArrayList ^nsSvcMHttp::IpSecure::GetAcl( void )
{
	return m_arIpSecInfs;
}
int nsSvcMHttp::IpSecure::GetDefaultMode( void )
{
	return m_nMode;
}



int nsSvcMHttp::IpSecure::RetMode( System::String ^strMode )
{
	int nRet;

	strMode = strMode->ToLower();
	if (        strMode->IndexOf( "permit" ) >= 0 ) {
		nRet = m_nMODE_Permit;
	} else if ( strMode->IndexOf( "deny"   ) >= 0 ) {
		nRet = m_nMODE_Deny;
	} else {
		nRet = -1;
	}

	return nRet;
}

