#include "stdafx.h"

#include "MailManage.h"
#include "..\etc\IoIni.h"
#include "..\etc\LogPlus.h"
#include "MailEnc.h"
#include "MSecure.h"

#include "pop3\pop3.h"

#include "..\MiniHttp\MHttpTray.h"



bool nsSvcMHttp::MailReactor::ChkPollMSvr( void )
{
	LogP		^pLogP = gcnew LogP();

	Pop3Manager		^pPop3		
		= gcnew Pop3Manager();

	bool blRet;

	/* [U[EpX[h̑M */
	blRet = pPop3->ConnectPop3();
	if ( blRet == false ) {
		return blRet;
	}

	array<int>		^iarMsgNoArray = nullptr;
	/* LIST ̑Mƌ̎擾 */
	blRet = pPop3->GetListPop3( iarMsgNoArray );
	if ( blRet == false ) {
		return blRet;
	}



	blRet = pPop3->RcvPop3( iarMsgNoArray->Length );
	if ( blRet == false ) {
		return blRet;
	}









	/* ׂ[̔ԍۑ */
	pLogP->LogOFWithDate( 0 , 
		"MailReactor::ChkPollMSvr2 : " + __LINE__ + 
		": CheckOrderMailExist() Ăяo" );

	System::Collections::ArrayList	^arHitList
		= gcnew System::Collections::ArrayList();

	for ( int nCnt=0; nCnt< iarMsgNoArray->Length; nCnt++ ) {
		if (CheckOrderMailExist( pPop3->m_arMailDatas[ nCnt] ) == true ) {
			arHitList->Add( nCnt );
		}
	}



	/* [̑茳`FbN */
	if ( arHitList->Count > 0 ) {
		for ( int nCnt = 0 ; nCnt < arHitList->Count; nCnt++ ) {

			int nMailNo = static_cast<int>(
						arHitList[ nCnt ] );

			bool blPermit
				= m_pMSecure->IsPermitDomain( 
					pPop3->m_arMailDatas[ nMailNo ]->m_strSender );
			if ( blPermit == false ) {

				String ^strMsgFilter = 
					"Ȃ悩烁[R}h߃tB^܂B:" +
					pPop3->m_arMailDatas[ nMailNo ]->m_strSender;

				m_pLogP->LogWithDate( strMsgFilter );
				
				try {
					MHttpTray		^pMHttpTray;
					pMHttpTray = gcnew MHttpTray();
					pMHttpTray->AddMessage( strMsgFilter );
					delete pMHttpTray;
				} catch ( System::Exception ^e ) {
					delete e;
				}
				delete strMsgFilter;

				arHitList->RemoveAt( nCnt );
				nCnt--;
			}
		}
		
	}





	/* URL ʒm邽߂Ƀ[𑗐M */
	bool blErr = false;
	if ( arHitList->Count > 0 ) {
		blRet = SendIpAddrInf( pPop3->m_arMailDatas, arHitList );

		if ( blRet == false ) {
			m_pLogP->LogOFWithDate( 0 , 
				"MailReactor::CheckSvrMail : SendIpAddrInf Ăяo false ԂB"
				);
			blErr = true;
		}
	}



	/* [T[o[ォ烁[폜 */
	blRet = false;
	if ( blErr == false ) {
		for ( int nDelCnt=0; nDelCnt < arHitList->Count ; nDelCnt++ ) {

			int nDelMailNo =
				static_cast<int>( arHitList[ nDelCnt ] );

			m_pLogP->LogOFWithDate( 0 , 
				"MailReactor::ChkPollMSvr2 : " + __LINE__ + 
				": DelMailInPop3() Ăяo " + nDelMailNo );

			bool blRetDelPo3 = pPop3->DeletePop3( nDelMailNo );
			if ( blRetDelPo3 != true ) {

				m_pLogP->LogOFWithDate( 0 , 
					"MailReactor::ChkPollMSvr2 : DelMailInPop3 ĂяoŃG[" );

				blErr = true;
				break;

			}
		}
	}

	for( int nCnt = 0; nCnt < arHitList->Count; nCnt++ ) {
		delete arHitList[ nCnt ];
	}
	delete arHitList;



	if ( blErr == true ) {
		pPop3->m_s->Close();
		delete pPop3->m_s;
		pPop3->m_s = nullptr;

		pPop3->EraseMailData();

		return blRet;

	}









	blRet = pPop3->ExitPop3();
	if ( blRet == false ) {
		return blRet;
	}
	delete pPop3;


	blRet = true;

	return blRet;
}
