#pragma once



#include "httpParse.h"
#include "secure\hSecure.h"
#include ".\MHttpTray.h"


namespace nsSvcMHttp

{

	using namespace		System;
	using namespace		System::Text;

	using namespace		System::Collections;

	using namespace System::Net;
	using namespace System::Net::Sockets;

	public ref class MiniHttp
	{
	public:
		MiniHttp();

		~MiniHttp();


	public:
		void StartMiniHttp();

		void ExitMiniHttp();


	public:
		void ReactSession();

	private:

		TcpListener^			m_server;
		array<Byte>^			m_pBuff;

		/* HTTP NGXg̃p[VO */
		ReadHttpSession			^m_HttpRead;
		/* HTTP ẽANV */
		MakeHttpRetData			^m_HttpRes;

		httpSecure				^m_phttpSecure;

		/* O\p̃gCANZXpNX */
		MHttpTray				^m_pMTray;

		int ReactOneSession( HttpRequestData ^%pHttpReq );

		bool IsSessionAlive( Socket ^s );

		System::Collections::ArrayList	^m_httpReqs;


		void OutLogBadSession( String ^strIp, array<Byte>^ byarRcvErrData );
		void OutLogSecureWarning( String ^strIp );
		void OutLogSendData( array<System::Byte>^ byarRcvErrData );



	};


}

