
#include "stdafx.h"
#include "Upload.h"


#include "..\..\..\etc\IOIni.h"


using namespace System;

nsSvcMHttp::UploadAFile::UploadAFile()
{
	;
}
nsSvcMHttp::UploadAFile::~UploadAFile()
{
	;
}

array<System::Byte> ^nsSvcMHttp::UploadAFile::Upload( System::String ^strFileName, array<System::Byte> ^byarData )
{
	String				^strRet = nullptr;
	array<Byte>			^byarRet = nullptr;

	IniInfo		^pIni = gcnew IniInfo();
	String		^strOutputFileName;
		
	pIni->ReadIni( IniInfo::KeyTable::STR_HTTPFILE_UPLOADDIR, strOutputFileName );
	delete pIni;

	strOutputFileName += "\\";

	bool	blOverWrite = false;


	System::IO::FileInfo		^FileInf = nullptr;

	try {
		FileInf	= gcnew System::IO::FileInfo( strFileName );
	} catch ( System::Exception	^e ) {
		delete e;
		delete FileInf;
		goto nsSvcMHttp_UploadAFile_Upload_ERROR;
	}

	strOutputFileName += FileInf->Name;


	delete FileInf;


	try {
		FileInf	= gcnew System::IO::FileInfo( strOutputFileName );
	} catch ( System::Exception	^e ) {
		delete e;
		delete FileInf;
		goto nsSvcMHttp_UploadAFile_Upload_ERROR;
	}


	if ( FileInf->Exists ) {
		blOverWrite = true;

		try {
			FileInf->Delete();
		} catch ( System::Exception ^e ) {
			delete FileInf;
			delete e;

			goto nsSvcMHttp_UploadAFile_Upload_ERROR;
		}
	}

	
	delete FileInf;

	System::IO::BinaryWriter	^bw = nullptr;
	try {
		bw = gcnew System::IO::BinaryWriter( 
					System::IO::File::Open( 
						strOutputFileName, 
						System::IO::FileMode::Create )
				);

		array<unsigned char>	^ucarData
			= gcnew array<unsigned char>( byarData->Length );

		for ( int nCnt = 0; nCnt < byarData->Length; nCnt++ ) {
			ucarData[ nCnt ] = (unsigned char)
								( byarData[ nCnt ] );
		}

		bw->Write( ucarData );

		delete ucarData;


		bw->Close();
		delete bw;
	} catch ( System::Exception ^e ) {
		delete e;
		delete bw;
		goto nsSvcMHttp_UploadAFile_Upload_ERROR;
	}




	strRet = String::Format( "file upload successed.<BR> : {0}<BR>", strOutputFileName );
	if ( blOverWrite ) {
		strRet = String::Concat( strRet, 
								 "<BR>(same file exsits,Overwrited)" );
	}



	byarRet = System::Text::Encoding::ASCII->GetBytes( strRet );
	delete strRet;


	delete strOutputFileName;
	return byarRet;



nsSvcMHttp_UploadAFile_Upload_ERROR:
	byarRet = System::Text::Encoding::ASCII->GetBytes( 
		"<BR>server upload error.<BR>" );



	delete strOutputFileName;
	return byarRet;
}
