
#include "stdafx.h"
#include "PerEnc.h"


#include "..\..\etc\RecKanji.h"


using namespace System;



nsSvcMHttp::PerEnc::PerEnc()
{
	;
}
nsSvcMHttp::PerEnc::~PerEnc()
{
	;
}


String ^nsSvcMHttp::PerEnc::GetPerEncSJIS( String ^strOrigData )
{
	return GetPerEnc( strOrigData );
}
String ^nsSvcMHttp::PerEnc::GetPerEncUTF8( String ^strOrigData )
{
	return GetPerEnc( strOrigData );
}


String ^nsSvcMHttp::PerEnc::GetPerEnc( String ^strOrigData )
{
	String		^strRet = nullptr;

	array<Byte>	^byarData
		= System::Text::Encoding::ASCII->GetBytes( strOrigData );

	strRet = GetPerEnc( byarData );
	delete byarData;

	return strRet;
}

String ^nsSvcMHttp::PerEnc::GetPerEnc( array<Byte> ^byarData )
{
	String		^strRet = nullptr;

	//return System::Text::Encoding::UTF8->GetString( byarData );

	int nPos = 0;
	while ( 1 ) {

		nPos = array<Byte>::IndexOf( byarData, Byte( '%' ), nPos );

		if ( nPos < 0 ) {
			break;
		}

		if ( nPos+2 > byarData->Length ) {
			break;
		}


		if (   !( ( byarData[ nPos+ 1 ] >= '0' && byarData[ nPos+ 1 ] <= '9'  ) ||
				  ( byarData[ nPos+ 1 ] >= 'a' && byarData[ nPos+ 1 ] <= 'f'  ) ||
				  ( byarData[ nPos+ 1 ] >= 'A' && byarData[ nPos+ 1 ] <= 'F'  ) 
				)
		   ) {
			nPos++;
			continue;
		}

		
		if ( !( 
				( byarData[ nPos+ 2 ] >= '0' && byarData[ nPos+ 2 ] <= '9'  ) ||
				( byarData[ nPos+ 2 ] >= 'a' && byarData[ nPos+ 2 ] <= 'f'  ) ||
				( byarData[ nPos+ 2 ] >= 'A' && byarData[ nPos+ 2 ] <= 'F'  ) 
			  )
		   ) {
			nPos++;
			continue;
		}


		/* %xx u */

		Byte    byarBuf;
		if (        byarData[ nPos+ 1 ] >= '0' && byarData[ nPos+ 1 ] <= '9'  ) {
			byarBuf = byarData[ nPos+ 1 ] - '0';
		} else if ( byarData[ nPos+ 1 ] >= 'a' && byarData[ nPos+ 1 ] <= 'f'  ) {
			byarBuf = byarData[ nPos+ 1 ] - 'a' + 10;
		} else {
			byarBuf = byarData[ nPos+ 1 ] - 'A' + 10;
		}
		byarBuf = byarBuf << 4;
		byarBuf &= 0xf0;
			
		if (        byarData[ nPos+ 2 ] >= '0' && byarData[ nPos+ 2 ] <= '9'  ) {
			byarBuf |= (byarData[ nPos+ 2 ] - '0');
		} else if ( byarData[ nPos+ 2 ] >= 'a' && byarData[ nPos+ 2 ] <= 'f'  ) {
			byarBuf |= (byarData[ nPos+ 2 ] - 'a' + 10);
		} else {
			byarBuf |= (byarData[ nPos+ 2 ] - 'A' + 10);
		}


		array<Byte>		^byarDataBuf
			= gcnew array<Byte>( byarData->Length -2 );
		
		array<Byte>::Copy( byarData, 0 ,
						   byarDataBuf, 0,
							nPos );
		byarDataBuf[ nPos ] = byarBuf;
		array<Byte>::Copy( byarData,    nPos+3,
						   byarDataBuf, nPos+1,
						   (byarData->Length-1) - (nPos+3) + 1 );

		delete byarData;
		byarData = byarDataBuf;
		delete byarDataBuf;
							

		nPos++;
	}



	//delete strOrigData;
	//strOrigData = System::Text::Encoding::GetEncoding( "SJIS" )->GetString( byarData );
	//strOrigData = System::Text::Encoding::GetEncoding( "UTF8" )->GetString( byarData );


	RecogKanji	^pRcK = gcnew RecogKanji();
	int nKanjiType = pRcK->ChkAllChars( byarData );

	if (            nKanjiType == pRcK->m_intSJIS       ) {
		strRet = System::Text::Encoding::GetEncoding( "SJIS" )->GetString( byarData );

	} else     if ( nKanjiType == pRcK->m_intJIS ) {
		strRet = System::Text::Encoding::GetEncoding( "iso-2022-jp" )->GetString( byarData );
	} else     if ( nKanjiType == pRcK->m_intEUC ) {
		strRet = System::Text::Encoding::GetEncoding( "EUC-jp" )->GetString( byarData );
	} else if ( nKanjiType == pRcK->m_intUTF8 ) {
		strRet = System::Text::Encoding::UTF8->GetString( byarData );
	} else {
		/* e`ԂŃGR[h݂ĎsȂm߂ */

		strRet 
			= System::Text::Encoding::GetEncoding( "SJIS" )->GetString( byarData );
		if ( strRet->IndexOf( "?" ) >= 0 ) {
			delete strRet;
			strRet 
				= System::Text::Encoding::GetEncoding( "EUC-jp" )->GetString( byarData );

			if ( strRet->IndexOf( "E" ) >= 0 ) {
				delete strRet;
				strRet 
					= System::Text::Encoding::UTF8->GetString( byarData );

			}

		}
	}

	/* uEUɔpXy[X "+" ɒu邽 */
	/* " " ɒu */
	strRet = strRet->Replace( "+", " " );

	delete pRcK;

	return strRet;
}