#include "StdAfx.h"



#include "..\CSvcManage\CSvcMan.h"


#include "..\SvcNameDef.h"




#include ".\MHttpTray.h"


#include "..\etc\IoIni.h"

#include ".\Secure\hSecure.h"


#include ".\frmHttp2Edit.h"


#include "frmSetup.h"




















	System::Void nsSvcMHttp::frmSetup::cmdStart_AppStart_Click(System::Object^  sender, System::EventArgs^  e) {


		 System::ServiceProcess::ServiceController			^pSvcControl;

		 try {

			pSvcControl = gcnew System::ServiceProcess::ServiceController( SVCNAMEDEF_SERVICEDESCRIPTION );
			pSvcControl->Start();
		 } catch ( System::Exception ^e ) {
			 delete pSvcControl;
			delete e;
			System::Windows::Forms::MessageBox::Show( "T[rX̋NɎs܂B" );
			return;
		 }
		 delete pSvcControl;


		 RefreshControlStatus();
		 

	 }
System::Void nsSvcMHttp::frmSetup::cmdStart_AppStop_Click(System::Object^  sender, System::EventArgs^  e) {


		 System::ServiceProcess::ServiceController			^pSvcControl;

		 try {

			pSvcControl = gcnew System::ServiceProcess::ServiceController( SVCNAMEDEF_SERVICEDESCRIPTION );
			pSvcControl->Stop();
		 } catch ( System::Exception ^e ) {
			 delete pSvcControl;
			delete e;
			System::Windows::Forms::MessageBox::Show( "T[rX̒~Ɏs܂B" );
			return;
		 }
		 delete pSvcControl;

		 RefreshControlStatus();

 }

System::Void nsSvcMHttp::frmSetup::frmSetup_Load(System::Object^  sender, System::EventArgs^  e) {

	 LoadIni();

	 m_blModified = false;
	 m_blRestart = false;

	 m_frmHttp2Edit = nullptr;

	tabControl1_SelectedIndexChanged( nullptr, nullptr);

	 RefreshControlStatus();
	 timForm->Enabled = true;


	 SetSubclass_lvwHttp2_Acl();
 }



System::ServiceProcess::ServiceController^% nsSvcMHttp::frmSetup::GetServiceInstance( void ) {

	System::ServiceProcess::ServiceController 
			^%pSvcControl = gcnew 
			System::ServiceProcess::ServiceController( SVCNAMEDEF_SERVICEDESCRIPTION );

	try {
		if ( pSvcControl->ServiceName == "" ) {
			delete pSvcControl;
			pSvcControl = nullptr;
		}
	} catch ( System::Exception ^e ) {

		delete pSvcControl;
		pSvcControl = nullptr;

		delete e;

	}
	return pSvcControl;
 }

System::Void nsSvcMHttp::frmSetup::RefreshControlStatus( void ) {

	 /* T[rX̏ԂmF */


	 System::ServiceProcess::ServiceController			^pSvcControl = nullptr;
	pSvcControl = GetServiceInstance();





	/*  N/I  */
	if ( pSvcControl ) {
		bool blStart, blStop;
		switch ( pSvcControl->Status ) {
		case System::ServiceProcess::ServiceControllerStatus::ContinuePending :
			blStart = true;		blStop = true;
			break;
		case System::ServiceProcess::ServiceControllerStatus::Paused :
			blStart = false;		blStop = false;
			break;
		case System::ServiceProcess::ServiceControllerStatus::Running :
			blStart = false;		blStop = true;
			break;
		case System::ServiceProcess::ServiceControllerStatus::StartPending :
			blStart = false;		blStop = false;
			break;
		case System::ServiceProcess::ServiceControllerStatus::Stopped :
			blStart = true;		blStop = false;
			break;
		case System::ServiceProcess::ServiceControllerStatus::StopPending :
			blStart = false;		blStop = false;
			break;
		}
		cmdStart_AppStart->Enabled = blStart;
		cmdStart_AppStop->Enabled  = blStop;

	} else {
		cmdStart_AppStart->Enabled = false;
		cmdStart_AppStop->Enabled  = false;
	}




	/* CXg[ */
	if ( pSvcControl ) {
		cmdInst_Install->Enabled = false;
		if ( pSvcControl->Status == 
			System::ServiceProcess::ServiceControllerStatus::Running ) {						
			cmdInst_Uninst->Enabled  = false;
		} else {
			cmdInst_Uninst->Enabled  = true;
		}
	} else {
		cmdInst_Install->Enabled = true;
		cmdInst_Uninst->Enabled  = false;
	}

	if ( m_blModified == true ) {
		cmdOK->Enabled = true;
		cmdApply->Enabled = true;
	} else {
		cmdOK->Enabled = false;
		cmdApply->Enabled = false;
	}
 }



System::Void nsSvcMHttp::frmSetup::timForm_Tick(System::Object^  sender, System::EventArgs^  e) {

	 RefreshControlStatus();

 }



System::Void nsSvcMHttp::frmSetup::cmdInst_Install_Click(System::Object^  sender, System::EventArgs^  e) {


CSvcMan		*pSvcManager;

pSvcManager = new CSvcMan();

/* T[rX WinApi œo^OƓɂKv */
pSvcManager->SetServiceName( reinterpret_cast<WCHAR *> ( SVCNAMEDEF_SERVICENAME_L  ) , 
							 reinterpret_cast<WCHAR *> ( SVCNAMEDEF_SERVICEDESCRIPTION_L  ) );

 pSvcManager->Resister();

 delete pSvcManager;


 RefreshControlStatus();
}



System::Void nsSvcMHttp::frmSetup::cmdInst_Uninst_Click(System::Object^  sender, System::EventArgs^  e) {


CSvcMan		*pSvcManager;

pSvcManager = new CSvcMan();

/* T[rX WinApi œo^OƓɂKv */
pSvcManager->SetServiceName( reinterpret_cast<WCHAR *> ( SVCNAMEDEF_SERVICENAME_L  ) , 
							 reinterpret_cast<WCHAR *> ( SVCNAMEDEF_SERVICEDESCRIPTION_L  ) );

 pSvcManager->UnResister();

 delete pSvcManager;



 RefreshControlStatus();
}



System::Void nsSvcMHttp::frmSetup::txtHttp1_Dir_TextChanged(System::Object^  sender, System::EventArgs^  e) {

	 if ( m_blModified == false )
		 	 RefreshControlStatus();

	 m_blModified = true;

 }
System::Void nsSvcMHttp::frmSetup::txtHttp1_DefaultFile_TextChanged(System::Object^  sender, System::EventArgs^  e) {

	 if ( m_blModified == false )
		 	 RefreshControlStatus();
	 m_blModified = true;

 }


System::Void nsSvcMHttp::frmSetup::txtHttp1_Port_TextChanged(System::Object^  sender, System::EventArgs^  e) {

	 if ( m_blModified == false )
		 	 RefreshControlStatus();
	 m_blModified = true;

 }


bool nsSvcMHttp::frmSetup::ChkInputData( void ) {

	 bool blRet = false;
	
	txtHttp1_Dir->Text = txtHttp1_Dir->Text->Trim();
	if ( !System::IO::Directory::Exists( txtHttp1_Dir->Text ) ) {

		tabControl1->SelectedIndex = 1;
		txtHttp1_Dir->Focus();
		txtHttp1_Dir->SelectAll();

		System::Windows::Forms::MessageBox::Show( 
			"uhtml t@C̏ꏊv"
			" Ŏw肵fBNg܂B" );
			
		return blRet;
	}


	txtHttp1_DefaultFile->Text = txtHttp1_DefaultFile->Text->Trim();
	

	txtHttp1_Port->Text = txtHttp1_Port->Text->Trim();

	int nPort = -1;
	try {
		nPort = System::Convert::ToInt16( txtHttp1_Port->Text );

	} catch ( System::Exception ^e ) {
		delete e;
		nPort = -1;
	}

	if ( nPort == -1 ) {
		tabControl1->SelectedIndex = 1;
		txtHttp1_Port->Focus();
		txtHttp1_Port->SelectAll();


		System::Windows::Forms::MessageBox::Show( 
			"uhttp ʐMɎgp|[gԍv"
			" Ŏw肷|[gԍ 0  65535 w肵ĉB" );

		return blRet;
	}

	return true;
 }


void nsSvcMHttp::frmSetup::UpdateIni( void ) {

	 bool blRet = false;


	if ( !m_blModified )		/* svȃR[hH */
		return;

	 blRet = ChkInputData();
	 if ( !blRet ) {
		return;
	 }

	 /* ini t@CXV */
	 bool blRestart;
	 SaveIni(&blRestart);

	 
	 if ( blRestart ) {

		 System::ServiceProcess::ServiceController	^pSContoler
				= GetServiceInstance();

		 if ( pSContoler != nullptr ) {

			if ( pSContoler->Status ==
				System::ServiceProcess::ServiceControllerStatus::Running ) {

				cmdStart_AppStop_Click( nullptr, nullptr );
				while ( 1 ) {

					/* ~Ď҂ */
					 System::ServiceProcess::ServiceController	^pSContoler2
							= GetServiceInstance();

					if ( pSContoler2->Status == 
						System::ServiceProcess::ServiceControllerStatus::Stopped ) {
						delete pSContoler2;
						break;
					}
					delete pSContoler2;
					System::Windows::Forms::Application::DoEvents();
				}
				


				cmdStart_AppStart_Click( nullptr, nullptr );
				while ( 1 ) {

					/* ~Ď҂ */
					 System::ServiceProcess::ServiceController	^pSContoler2
							= GetServiceInstance();

					if ( pSContoler2->Status == 
						System::ServiceProcess::ServiceControllerStatus::Running ) {
						delete pSContoler2;
						break;
					}
					delete pSContoler2;
					System::Windows::Forms::Application::DoEvents();
				}
			}

		 }

	 }
	 


	m_blModified = false;
	 RefreshControlStatus();
 }



System::Void nsSvcMHttp::frmSetup::SaveIni( bool *blpRestart ) {
	 
	IniInfo		^pIniInfo
		= gcnew IniInfo();

	bool blRet;

	blRet = pIniInfo->WriteIni( 
		IniInfo::KeyTable::STR_HTTPFILE_TOPDIR, 
		txtHttp1_Dir->Text );

	blRet = pIniInfo->WriteIni( 
		IniInfo::KeyTable::STR_HTTPFILE_DEFAULTNAME, 
		txtHttp1_DefaultFile->Text );

	blRet = pIniInfo->WriteIni( 
		IniInfo::KeyTable::STR_HTTPFILE_PORT, 
		txtHttp1_Port->Text );

	delete pIniInfo;

	*blpRestart = true;
 }



System::Void nsSvcMHttp::frmSetup::LoadIni( void ) {
	IniInfo		^pIniInfo
		= gcnew IniInfo();

	bool blRet;
	String		^strRead = nullptr;

	/*******************************************/
	/* html t@C̈ʒuAftHgt@C */
	/*******************************************/
	blRet = pIniInfo->ReadIni( 
		IniInfo::KeyTable::STR_HTTPFILE_TOPDIR, 
		strRead );
	if ( blRet ) {
		txtHttp1_Dir->Text = static_cast<String^>( strRead->Clone() );
	}
	delete strRead;
	strRead = nullptr;

	blRet = pIniInfo->ReadIni( 
		IniInfo::KeyTable::STR_HTTPFILE_DEFAULTNAME, 
		strRead );
	if ( blRet ) {
		txtHttp1_DefaultFile->Text = static_cast<String^>( strRead->Clone() );
	}
	delete strRead;
	strRead = nullptr;

	blRet = pIniInfo->ReadIni( 
		IniInfo::KeyTable::STR_HTTPFILE_PORT, 
		strRead );
	if ( blRet ) {
		txtHttp1_Port->Text = static_cast<String^>( strRead->Clone() );
	}
	delete strRead;
	strRead = nullptr;





	/*******************************************/
	/* html ANZX                       */
	/*******************************************/

	/* HP-ACL */
	httpSecure		^phttpSecure
		= gcnew httpSecure();
	phttpSecure->GetIni();

	if ( phttpSecure->GetDefaultMode() 
		== IpSecure::m_nMODE_Deny ) {
		chkHttp2_Deny->CheckState = System::Windows::Forms::CheckState::Checked;
	} else {
		chkHttp2_Deny->CheckState = System::Windows::Forms::CheckState::Unchecked;
	}



	lvwHttp2_Acl->Clear();

	lvwHttp2_Acl->View = System::Windows::Forms::View::Details;

	lvwHttp2_Acl->Columns->Clear();
	lvwHttp2_Acl->Columns->Add( "/֎~" );
	lvwHttp2_Acl->Columns->Add( "IP/hC(ꕔ)" );

	lvwHttp2_Acl->Columns[ 0 ]->Width = 80;
	lvwHttp2_Acl->Columns[ 1 ]->Width = 300;


	System::Collections::ArrayList	^arSecInfs
		= phttpSecure->GetAcl();
	IpSecureInf		^pIpSecureInf = nullptr;
	for ( int nCnt = 0 ; nCnt < arSecInfs->Count; nCnt++ ) {

		IpSecureInf		^pIpSecureInf = 
			static_cast<IpSecureInf^>( arSecInfs[ nCnt ] );
	
		System::Windows::Forms::ListViewItem	^plviItem
			= gcnew System::Windows::Forms::ListViewItem();


		plviItem->SubItems->Clear();
		plviItem->Checked = false;

		
		String		^strAdd = nullptr;
		switch (pIpSecureInf->m_nPermitMode ) {
		case IpSecure::m_nMODE_Permit:
			strAdd = "";
			break;
		case IpSecure::m_nMODE_Deny:
			strAdd = "֎~";
			break;
		case IpSecure::m_nMODE_None:
			strAdd = "|||";
			break;
		}
		plviItem->SubItems[0]->Text = strAdd;

		



		
		if ( pIpSecureInf->IsHaveIp() ) {

			System::Text::StringBuilder	^stb
				= gcnew System::Text::StringBuilder();

			stb->AppendFormat( "{0}.", pIpSecureInf->m_byarIp[ 0 ] );
			stb->AppendFormat( "{0}.", pIpSecureInf->m_byarIp[ 1 ] );
			stb->AppendFormat( "{0}.", pIpSecureInf->m_byarIp[ 2 ] );
			stb->AppendFormat( "{0}",  pIpSecureInf->m_byarIp[ 3 ] );

			int		nNetMask = pIpSecureInf->RetNetMask();
			
			stb->AppendFormat( "/{0}", nNetMask );


			
			String ^strIp =
				System::Convert::ToString( stb->ToString() );

			delete stb;
			plviItem->SubItems->Add( strIp );
			
		} else {

			plviItem->SubItems->Add( pIpSecureInf->m_strDomain );

		}
		



		lvwHttp2_Acl->Items->Add( plviItem );
		


	}





	delete phttpSecure;

	delete pIniInfo;
 }



System::Void nsSvcMHttp::frmSetup::cmdApply_Click(System::Object^  sender, System::EventArgs^  e) {
	 UpdateIni();
 }



System::Void nsSvcMHttp::frmSetup::cmdOK_Click(System::Object^  sender, System::EventArgs^  e) {
	UpdateIni();
	this->Close();
 }
System::Void nsSvcMHttp::frmSetup::cmdCancel_Click(System::Object^  sender, System::EventArgs^  e) {
	 this->Close();
 }


System::Void nsSvcMHttp::frmSetup::tabControl1_SelectedIndexChanged(System::Object^  sender, System::EventArgs^  e)
{

	switch ( tabControl1->SelectedIndex ) {
	case 0:		/* NE~ */
		{

			String ^strURLppp   = GetURLPPP();
			String ^strURLLocal = GetURLLocal();
			txtDesc->Text = 
				"MHTTP Năz[y[WuEUŌ悤ɂ܂B\r\n"
				"ANZXURL\r\n" 
				"   " + strURLppp   + "\r\n" 
				"   " + strURLLocal + "\r\n" 
				"łB";

			delete strURLppp;
			delete strURLLocal;
		}

		break;



	case 1:		/* html t@C̈ʒuAftHgt@C */
		/* tH[JX\bh̓n}邩炠܂gp̂c */
		txtHttp1_Dir->Focus();
		break;



	 case 2:
		txtDesc->Text = "";
		 break;
	 case 3:
		txtDesc->Text = "";
		 break;

	 case 4:	/* CXg[/ACXg[ */
		txtDesc->Text = 
			"MHTTP CXg[܂B\r\n"
			"MHTTP ́A Windows T[rXƌĂ΂\r\n" + 
			"풓vOǗ OS @\ɓo^\r\n"
			"ɂ菉߂ċN܂B\r\n" + 
			"̂߃OCĂȂĂ MHTTP ͓삵܂B\r\n" + 
			"\r\n" + 
			"̂MHTTP ̋N~̓Rg[plAǗc[\r\n" + 
			"uT[rXvNE~so܂B\r\n" + 
			"܂xCXg[ MHHTP ́AăCXg[܂ł\r\n" + 
			"mhttp.exe ̈ʒuύXĂ͂܂B\r\n" + 
			"MHTTP ɒ~ENȂȂ܂B\r\n" + 
			"\r\n" + 
			"܂ MHTTP ̃ACXg[͖{\tgォ̂݉\łB\r\n" + 
			"MHTTP ACXg[E폜ۂɂ͕K{ʏォs悤ɂĉB\r\n" + 
			"\r\n" + 
			"ȂCXg[/ACXg[̓R}hvvgȉ\r\n" + 
			"R}hw肷鎖ł\łB\r\n" + 
			"    Prompt> mhttp.exe -register               CXg[\r\n" + 
			"    Prompt> mhttp.exe -unregister             ACXg[\r\n" + 
			"";
		 break;



	}

	 
}


System::Void nsSvcMHttp::frmSetup::SetDesc_tabHttp1(System::Object^  sender, System::EventArgs^  e)
{
	//
	//
	//
	if ( sender->Equals( static_cast<System::Object^>( txtHttp1_Dir ) ) ) {


		String ^strURLppp   = GetURLPPP();
		String ^strURLLocal = GetURLLocal();
		txtDesc->Text = 
			"MHTTP T[o[̂tqk\r\n"
			"   " + strURLppp   + "\r\n" + 
			"   " + strURLLocal + "\r\n" + 
			"ɃANZXɕ\ob\r\n" + 
			"fBNgʒuw肵܂B\r\n" +
			"\r\n" + 
			"URL 瑼̃fBNgw肵ꍇA\r\n"
			"Ŏw肵fBNg\r\n" + 
			"ΈʒuɂȂ܂B";


		delete strURLppp;
		delete strURLLocal;
		

	} else 
	if ( sender->Equals( static_cast<System::Object^>( txtHttp1_DefaultFile ) ) ) {
		String ^strURLppp   = GetURLPPP();
		String ^strURLLocal = GetURLLocal();

		txtDesc->Text = 
		"   " + strURLppp   + "\r\n" + 
		"   " + strURLLocal + "\r\n" + 
		"ɃANZXɍŏ̃t@Cw肵܂B\r\n";

		delete strURLppp;
		delete strURLLocal;

	} else 
	if ( sender->Equals( static_cast<System::Object^>( txtHttp1_Port ) ) ) {
		txtDesc->Text = 
		"T[o[󂯕t TCP ڑ̃|[gԍ\r\n" + 
		"0`65535 ̊ԂŎw肵܂B\r\n" + 
		"\r\n" + 
		"ʓI HTTP T[oŎgp|[gԍ 80 ԂłA\r\n" + 
		"80 ԂƈقȂ|[gԍgp鎖ŊiiɃZLeB\r\n" + 
		"サ܂B" + 
		"\r\n" + 
		"Ȃ windows @WIɉĂ|[gA137-139,445 Ԃ\r\n" + 
		"ɎgpĂ|[gԍw肵Ă삵܂B";
	}

}





String^ nsSvcMHttp::frmSetup::GetURLPPP( void )
{
	String		^strPort = nullptr;
	IniInfo		^pIniInfo
		= gcnew IniInfo();
	bool blRet = 
		pIniInfo->ReadIni(
				IniInfo::KeyTable::STR_HTTPFILE_PORT, 
				strPort );
	if ( blRet == false ) {
		delete strPort;
		strPort = "8080";
	}


	String		^strPPPIp = nullptr;
	blRet = 
		pIniInfo->ReadIni(
		IniInfo::KeyTable::STR_SYSLOGD_FIRSTPPPIP, 
				strPPPIp );
	if ( blRet == false ) {
		delete strPPPIp;
		strPPPIp = "xx.xx.xx.xx";
	}

	delete pIniInfo;

	String	^strUrlPPP = nullptr;

	strUrlPPP = 
		"http://" + strPPPIp + ":" + strPort + "/";
	delete strPort;
	delete strPPPIp;

	return strUrlPPP;
}


String^ nsSvcMHttp::frmSetup::GetURLLocal( void )
{
	String		^strPort = nullptr;
	IniInfo		^pIniInfo
		= gcnew IniInfo();
	bool blRet = 
		pIniInfo->ReadIni(
				IniInfo::KeyTable::STR_HTTPFILE_PORT, 
				strPort );
	if ( blRet == false ) {
		delete strPort;
		strPort = "8080";
	}
	delete pIniInfo;

	String	^strUrlPPP = nullptr;

	strUrlPPP = 
		"http://localhost:" + strPort + "/";
	delete strPort;

	return strUrlPPP;
}










System::Void nsSvcMHttp::frmSetup::SetlvwHttp2_Acl( int nIndex, int nMode, String ^strIpOrDomain ) {
			
	String ^strAdd;
	switch ( nMode ) {
	case IpSecure::m_nMODE_Permit:
		strAdd = "";
		break;
	case IpSecure::m_nMODE_Deny:
		strAdd = "֎~";
		break;
	case IpSecure::m_nMODE_None:
	default:
		strAdd = "|||";
		break;
	}
	lvwHttp2_Acl->Items[ nIndex ]->Text = strAdd;

	lvwHttp2_Acl->Items[ nIndex ]->SubItems[ 1 ]->Text = strIpOrDomain;
}










































System::Void nsSvcMHttp::frmSetup::lvwHttp2_Acl_Click(System::Object^  sender, System::EventArgs^  e) {

	if ( lvwHttp2_Acl->SelectedIndices->Count > 1 ||
		 lvwHttp2_Acl->SelectedIndices->Count < 1 ) {
		return;
	}

	int nIndex = lvwHttp2_Acl->SelectedIndices[ 0 ];

	if ( m_frmHttp2Edit == nullptr ) {
		m_frmHttp2Edit = gcnew nsSvcMHttp::frmHttp2Edit();
		static_cast<nsSvcMHttp::frmHttp2Edit^>( 
			m_frmHttp2Edit )->SetParentForm( static_cast<System::Object^>( this ) );
	}


	int nMode;
	if ( lvwHttp2_Acl->Items[ nIndex ]->Text == "" ) {
		nMode = IpSecure::m_nMODE_Permit;
	} else if ( lvwHttp2_Acl->Items[ nIndex ]->Text == "֎~" ) {
		nMode = IpSecure::m_nMODE_Deny;
	} else {
		nMode = IpSecure::m_nMODE_None;
	}
	

	static_cast<nsSvcMHttp::frmHttp2Edit^>( m_frmHttp2Edit )->SetCtrl( 
							nIndex, 
							 nMode, 
							 lvwHttp2_Acl->Items[ nIndex ]->SubItems[ 1 ]->Text );
	static_cast<nsSvcMHttp::frmHttp2Edit^>( m_frmHttp2Edit )->Visible= true;
	

 }






System::Void nsSvcMHttp::frmSetup::frmSetup_FormClosing(System::Object^  sender, System::Windows::Forms::FormClosingEventArgs^  e) {
	 if ( m_frmHttp2Edit != nullptr )  {
		static_cast<nsSvcMHttp::frmHttp2Edit^>( m_frmHttp2Edit )->Close();
		
		delete m_frmHttp2Edit;
		m_frmHttp2Edit = nullptr;

	 }

	e->Cancel = false;

	
	UnsetSubclass_lvwHttp2_Acl();

}





System::Void nsSvcMHttp::frmSetup::lvwHttp2_Acl_SelectedIndexChanged(System::Object^  sender, System::EventArgs^  e)
{
	// L[{[h̑IύX͖ĎŁEEE
	// ÂHHH

	if ( lvwHttp2_Acl->SelectedIndices->Count > 0 ) {
		cmdHttp2_Del->Enabled  = true;
		cmdHttp2_Up->Enabled   = true;
		cmdHttp2_Down->Enabled = true;

	} else {
		cmdHttp2_Del->Enabled = false;
		cmdHttp2_Up->Enabled = false;
		cmdHttp2_Down->Enabled = false;
	}
}





System::Void nsSvcMHttp::frmSetup::SelectlvwHttp2_Acl( void )
{
	
	System::Drawing::Point point = System::Windows::Forms::Cursor::Position;

	
	point = this->PointToClient( point );
	point.Y -= lvwHttp2_Acl->Top;
	point.X -= lvwHttp2_Acl->Left;


	int nRowSize = (int)lvwHttp2_Acl->Font->Size * 2;		// TZ
	if ( lvwHttp2_Acl->SelectedIndices->Count > 0 ) {
		nRowSize = lvwHttp2_Acl->TopItem->Bounds.Top;
	}
	point.Y -= nRowSize + 4;		//  4 ͉̍c
									// ˑH


#if 0
	System::Diagnostics::TextWriterTraceListener ^myWriter 
		= gcnew System::Diagnostics::TextWriterTraceListener( System::Console::Out );
	System::Diagnostics::Debug::Listeners->Clear();
	System::Diagnostics::Debug::Listeners->Add( myWriter );
#endif

	int nCol = -1;
	for ( int nCnt = 0; nCnt < lvwHttp2_Acl->Items->Count; nCnt++ ) {

		int nY1 = lvwHttp2_Acl->Items[nCnt]->Bounds.Top;
		int nY2 = lvwHttp2_Acl->Items[nCnt]->Bounds.Top + 
				  lvwHttp2_Acl->Items[nCnt]->Bounds.Height;

		if ( point.Y >= nY1 && 
			 point.Y <= nY2 ) {
			nCol = nCnt;
			break;
		}



#if 0
		System::Diagnostics::Debug::Print( String::Format("point.Y={3},nCnt={0}, nY1={1}, nY2={2}", nCnt, nY1, nY2, point.Y ) );
#endif

	}
	 

	if ( nCol == -1 ) {
		return;
	}

	//nCol -= lvwHttp2_Acl->TopItem->Index;
	
	lvwHttp2_Acl->SelectedIndices->Clear();
	//lvwHttp2_Acl->SelectedIndices->Add( nCol );
	lvwHttp2_Acl->Items[ nCol ]->Selected = true;

}


System::Void nsSvcMHttp::frmSetup::SetSubclass_lvwHttp2_Acl( void ) 
{
	 m_plvwHttp2_Acl_wndProc = gcnew WndProcDelegate( this, &frmSetup::lvwHttp2_Acl_WndProc );
	 m_plvwHttp2_Acl_wndProcPtr = System::Runtime::InteropServices::Marshal::GetFunctionPointerForDelegate( m_plvwHttp2_Acl_wndProc );

	 m_lvwHttp2_Acl_uloldWndProc = SetWindowLong( (HWND)lvwHttp2_Acl->Handle.ToInt32(), GWL_WNDPROC, (LONG)m_plvwHttp2_Acl_wndProcPtr.ToPointer());
}


System::Void nsSvcMHttp::frmSetup::UnsetSubclass_lvwHttp2_Acl( void ) 
{
	SetWindowLong( (HWND)lvwHttp2_Acl->Handle.ToInt32(), GWL_WNDPROC, (LONG)m_lvwHttp2_Acl_uloldWndProc );
	delete m_plvwHttp2_Acl_wndProc;
}


int nsSvcMHttp::frmSetup::lvwHttp2_Acl_WndProc(IntPtr hwnd, unsigned int msg, unsigned int wParam, int lParam)
{

// Listen for operating system messages.
switch ( msg )
{
	case WM_LBUTTONDOWN:
		/* JAXN[o[ȊȎS̃CxgE */
		   // The WParam value identifies what is occurring.

		int x = LOWORD(  lParam );
		int y = HIWORD(  lParam );

		System::Drawing::Point	point;
		point.X = x;
		point.Y = y;

		//point = this->PointToClient( point );

		if ( 0                           <=   point.X && 
			 lvwHttp2_Acl->Bounds.Width  >=   point.X && 
			 0                           <=   point.Y && 
			 lvwHttp2_Acl->Bounds.Height >=   point.Y ) {

			//System::Windows::Forms::MessageBox::Show( "AAA" );
			SelectlvwHttp2_Acl();
			lvwHttp2_Acl_Click( nullptr, nullptr );

			return 1;

		}

		break;

	}


	return CallWindowProc( (WNDPROC)m_lvwHttp2_Acl_uloldWndProc, (HWND)hwnd.ToInt32(), msg, wParam, lParam);
}



