
#include "stdafx.h"
#include <Windows.h>

#include "IoIni.h"


using namespace System;


using namespace nsSvcMHttp;



///<summary>
///
///</summary>
///<param name="sender"></param>
///<param name="e"></param>
///<remarks></remarks>


nsSvcMHttp::IniInfo::IniInfo()
{

	int			nNum;
	nNum = nsSvcMHttp::IniInfo::KeyTable::STR_INI_MAX;
	m_clsarKeySecInfo = gcnew array<clsKeyAndSecs ^>( nNum );


	for ( int nCnt = 0 ; nCnt < m_clsarKeySecInfo->Length; nCnt++ ) {
		m_clsarKeySecInfo[ nCnt ] = gcnew clsKeyAndSecs();
	}

	nNum = nsSvcMHttp::IniInfo::KeyTable::STR_HTTPFILE_TOPDIR;
	m_clsarKeySecInfo[  nNum ]->strSection = "AppInfo";
	m_clsarKeySecInfo[  nNum ]->strKey     = "HttpTopDir";

	nNum = nsSvcMHttp::IniInfo::KeyTable::STR_HTTPFILE_DEFAULTNAME;
	m_clsarKeySecInfo[  nNum ]->strSection = "AppInfo";
	m_clsarKeySecInfo[  nNum ]->strKey     = "HttpDefaultFileName";

	nNum = nsSvcMHttp::IniInfo::KeyTable::STR_HTTPFILE_PORT;
	m_clsarKeySecInfo[  nNum ]->strSection = "AppInfo";
	m_clsarKeySecInfo[  nNum ]->strKey     = "HttpPort";

	nNum = nsSvcMHttp::IniInfo::KeyTable::STR_HTTPFILE_ACCEPT_MODE;
	m_clsarKeySecInfo[  nNum ]->strSection = "AppInfo";
	m_clsarKeySecInfo[  nNum ]->strKey     = "HttpAcceptPermitMode";

	nNum = nsSvcMHttp::IniInfo::KeyTable::STR_HTTPFILE_ACCEPT_DOMAIN;
	m_clsarKeySecInfo[  nNum ]->strSection = "AppInfo";
	m_clsarKeySecInfo[  nNum ]->strKey     = "HttpAcceptDomains";

	nNum = nsSvcMHttp::IniInfo::KeyTable::STR_HTTPFILE_UPLOADDIR;
	m_clsarKeySecInfo[  nNum ]->strSection = "AppInfo";
	m_clsarKeySecInfo[  nNum ]->strKey     = "HttpUploadDir";

	nNum = nsSvcMHttp::IniInfo::KeyTable::STR_SYSLOGD_FIRSTPPPIP;
	m_clsarKeySecInfo[  nNum ]->strSection = "AppInfo";
	m_clsarKeySecInfo[  nNum ]->strKey     = "SyslogFirstPppIpAddress";

	nNum = nsSvcMHttp::IniInfo::KeyTable::STR_NV3MODEM_USEPOLLING;
	m_clsarKeySecInfo[  nNum ]->strSection = "AppInfo";
	m_clsarKeySecInfo[  nNum ]->strKey     = "NV3Modem_IpAskEnable";

	nNum = nsSvcMHttp::IniInfo::KeyTable::STR_NV3MODEM_IPADDRESS;
	m_clsarKeySecInfo[  nNum ]->strSection = "AppInfo";
	m_clsarKeySecInfo[  nNum ]->strKey     = "NV3Modem_IpAddress";

	nNum = nsSvcMHttp::IniInfo::KeyTable::STR_NV3MODEM_USERNAME;
	m_clsarKeySecInfo[  nNum ]->strSection = "AppInfo";
	m_clsarKeySecInfo[  nNum ]->strKey     = "NV3Modem_UserName";

	nNum = nsSvcMHttp::IniInfo::KeyTable::STR_NV3MODEM_PASSWORD;
	m_clsarKeySecInfo[  nNum ]->strSection = "AppInfo";
	m_clsarKeySecInfo[  nNum ]->strKey     = "NV3Modem_Password";





	nNum = nsSvcMHttp::IniInfo::KeyTable::STR_PRS300MODEM_USEPOLLING;
	m_clsarKeySecInfo[  nNum ]->strSection = "AppInfo";
	m_clsarKeySecInfo[  nNum ]->strKey     = "PRS300Modem_IpAskEnable";

	nNum = nsSvcMHttp::IniInfo::KeyTable::STR_PRS300MODEM_IPADDRESS;
	m_clsarKeySecInfo[  nNum ]->strSection = "AppInfo";
	m_clsarKeySecInfo[  nNum ]->strKey     = "PRS300Modem_IpAddress";

	nNum = nsSvcMHttp::IniInfo::KeyTable::STR_PRS300MODEM_USERNAME;
	m_clsarKeySecInfo[  nNum ]->strSection = "AppInfo";
	m_clsarKeySecInfo[  nNum ]->strKey     = "PRS300Modem_UserName";

	nNum = nsSvcMHttp::IniInfo::KeyTable::STR_PRS300MODEM_PASSWORD;
	m_clsarKeySecInfo[  nNum ]->strSection = "AppInfo";
	m_clsarKeySecInfo[  nNum ]->strKey     = "PRS300Modem_Password";



	nNum = nsSvcMHttp::IniInfo::KeyTable::STR_MAILMANAGE_PO3POLLINGTIME_SEC;
	m_clsarKeySecInfo[  nNum ]->strSection = "AppInfo";
	m_clsarKeySecInfo[  nNum ]->strKey     = "Pop3PollingIntervalSEC";

	nNum = nsSvcMHttp::IniInfo::KeyTable::STR_MAILMANAGE_POLLMAILSVR_SVRNAME;
	m_clsarKeySecInfo[  nNum ]->strSection = "AppInfo";
	m_clsarKeySecInfo[  nNum ]->strKey     = "MailWatch_WatchPop3ServerName";

	nNum = nsSvcMHttp::IniInfo::KeyTable::STR_MAILMANAGE_POLLMAILSVR_SVRPORT;
	m_clsarKeySecInfo[  nNum ]->strSection = "AppInfo";
	m_clsarKeySecInfo[  nNum ]->strKey     = "MailWatch_WatchPop3ServerPort";

	nNum = nsSvcMHttp::IniInfo::KeyTable::STR_MAILMANAGE_POLLMAILSVR_USER;
	m_clsarKeySecInfo[  nNum ]->strSection = "AppInfo";
	m_clsarKeySecInfo[  nNum ]->strKey     = "MailWatch_WatchPop3UserName";

	nNum = nsSvcMHttp::IniInfo::KeyTable::STR_MAILMANAGE_POLLMAILSVR_PASSWORD;
	m_clsarKeySecInfo[  nNum ]->strSection = "AppInfo";
	m_clsarKeySecInfo[  nNum ]->strKey     = "MailWatch_WatchPop3Password";

	nNum = nsSvcMHttp::IniInfo::KeyTable::STR_MAILMANAGE_RETURN_MAILSVR_SVRNAME;
	m_clsarKeySecInfo[ nNum ]->strSection = "AppInfo";
	m_clsarKeySecInfo[ nNum ]->strKey     = "MailReturn_SMTPServerName";

	nNum = nsSvcMHttp::IniInfo::KeyTable::STR_MAILMANAGE_RETURN_MAILSVR_SVRPORT;
	m_clsarKeySecInfo[ nNum ]->strSection = "AppInfo";
	m_clsarKeySecInfo[ nNum ]->strKey     = "MailReturn_SMTPServerPort";

	nNum = nsSvcMHttp::IniInfo::KeyTable::STR_MAILMANAGE_RETURN_MAILSVR_MAILADDRESS;
	m_clsarKeySecInfo[ nNum ]->strSection = "AppInfo";
	m_clsarKeySecInfo[ nNum ]->strKey     = "MailReturn_SMTPMailAddress";

	nNum = nsSvcMHttp::IniInfo::KeyTable::STR_EXEFILE_PERMIT;
	m_clsarKeySecInfo[ nNum ]->strSection = "AppInfo";
	m_clsarKeySecInfo[ nNum ]->strKey     = "ExeFilePermit";

	nNum = nsSvcMHttp::IniInfo::KeyTable::STR_EXEFILE_PERMITFILENAMEPART;
	m_clsarKeySecInfo[ nNum ]->strSection = "AppInfo";
	m_clsarKeySecInfo[ nNum ]->strKey     = "ExeFilePermitNamePart";


	nNum = nsSvcMHttp::IniInfo::KeyTable::STR_MAILCMD_MAILREACT_GETURL_SUBJECT;
	m_clsarKeySecInfo[ nNum ]->strSection = "MailCommand";
	m_clsarKeySecInfo[ nNum ]->strKey     = "CMD_GetHttpUrl_Subject";

	nNum = nsSvcMHttp::IniInfo::KeyTable::STR_MAILCMD_MAILREACT_PERMIT_MODE;
	m_clsarKeySecInfo[ nNum ]->strSection = "MailCommand";
	m_clsarKeySecInfo[ nNum ]->strKey     = "PermitMode";

	nNum = nsSvcMHttp::IniInfo::KeyTable::STR_MAILCMD_MAILREACT_PERMIT_DOMAIN;
	m_clsarKeySecInfo[ nNum ]->strSection = "MailCommand";
	m_clsarKeySecInfo[ nNum ]->strKey     = "AccessDomains";

	nNum = nsSvcMHttp::IniInfo::KeyTable::STR_DEBUG_DEBUGOUPUT;
	m_clsarKeySecInfo[ nNum ]->strSection = "Debug";
	m_clsarKeySecInfo[ nNum ]->strKey     = "DebugLogOutput";

	m_strIniFileName = nullptr;
}

nsSvcMHttp::IniInfo::~IniInfo()
{
	if ( m_strIniFileName != nullptr )
		delete m_strIniFileName;

	for ( int nCnt = 0 ; nCnt < m_clsarKeySecInfo->Length; nCnt++ ) {
		delete m_clsarKeySecInfo[ nCnt ];
	}
	delete [] m_clsarKeySecInfo;
}




nsSvcMHttp::IniInfo::clsKeyAndSecs::clsKeyAndSecs()
{
	strSection = nullptr;
	strKey = nullptr;
}
nsSvcMHttp::IniInfo::clsKeyAndSecs::~clsKeyAndSecs()
{
	if (strSection!=nullptr)
		delete strSection;
	strSection = nullptr;

	if (strKey!=nullptr)
		delete strKey;
	strKey = nullptr;
}





bool nsSvcMHttp::IniInfo::ReadIni( int intDataType , String ^%strData )
{
	strData = gcnew String ( "noread" );
	bool		blRet 
		= this->IOIni( intDataType, strData, false );

	return blRet;
}


bool nsSvcMHttp::IniInfo::ReadIni( int intDataType , Int32 ^%int32Data )
{
	String ^strData = gcnew String ( "noread" );
	bool		blRet 
		= this->IOIni( intDataType, strData, false );

	try {
		int32Data = System::Convert::ToInt32( strData );
	} catch ( Exception ^e ) {
		delete e;
		blRet = false;
		int32Data = -1;

	}

	return blRet;
}



/*
  // obj ɖړĨf[^^ŒlZbgȂII 


bool nsSvcMHttp::IniInfo::ReadIni( int intDataType , Object ^%obj )
{
	String		^strData = gcnew String ( "noread" );
	bool		blRet 
		= this->IOIni( intDataType, strData, false );

	if (blRet) {


		if ( obj->GetType() == System::String::typeid ) {

			obj = gcnew String( strData );

		} else if ( obj->GetType() == bool::typeid ) {

			bool		^blData;
			try {
				blData = System::Convert::ToBoolean( strData );
				obj = blData;
			} catch ( System::Exception ^e) {
				delete e;
				blRet = false;
			}

		} else if ( obj->GetType() == System::Int16::typeid ) {

			System::Int16		^iRet16;
			try {
				iRet16 = System::Convert::ToInt16( strData );
				obj = iRet16;
			} catch ( System::Exception ^e) {
				delete e;
				blRet = false;
			}

		} else if ( obj->GetType() == System::Int32::typeid ) {

			System::Int32		^iRet32;
			try {
				iRet32 = System::Convert::ToInt32( strData );
				obj = iRet32;
			} catch ( System::Exception ^e) {
				delete e;
				blRet = false;
			}

		}

	}

	return blRet;
}
*/


bool nsSvcMHttp::IniInfo::WriteIni( int intDataType, Object ^%obj )
{
	String^		strData = obj->ToString();

	bool		blRet 
		= this->IOIni( intDataType, strData, true );

	delete strData;
	return blRet;
}



bool nsSvcMHttp::IniInfo::IOIni( int intDataType, String ^%strData, bool blWrite )
{


	if ( m_strIniFileName == nullptr ) {
		/* win32 gp֐ */
		HMODULE	 mHModule;
		TCHAR	tszAppDir[ MAX_PATH ];


		/****************************************/
		/*  EXE ƓtH_ ini ɃANZX */
		/****************************************/

		mHModule = GetModuleHandle( NULL );
		if ( mHModule == NULL ) {
			return false;
		}
		DWORD dwRet = GetModuleFileName( mHModule, tszAppDir, MAX_PATH );
		if ( !dwRet )
			return false;

		
		TCHAR drive[_MAX_DRIVE];
		TCHAR dir[_MAX_DIR];
		TCHAR fname[_MAX_FNAME];
		TCHAR ext[_MAX_EXT];

		_wsplitpath_s( tszAppDir, 
					drive, _MAX_DRIVE,
					dir,   _MAX_DIR, 
					fname, _MAX_FNAME, 
					ext ,  _MAX_EXT
				 );

		wcscpy_s( tszAppDir, sizeof( tszAppDir)/sizeof(TCHAR), drive );
		wcscat_s( tszAppDir, sizeof(tszAppDir)/sizeof(TCHAR), dir );
		wcscat_s( tszAppDir, sizeof(tszAppDir)/sizeof(TCHAR), fname );
		wcscat_s( tszAppDir, sizeof(tszAppDir)/sizeof(TCHAR), L".ini" );



		m_strIniFileName= gcnew System::String( tszAppDir );

	}




	if ( intDataType < 0 ||
		intDataType >= KeyTable::STR_INI_MAX ) {
		return false;
	}

	String		^strDefault = gcnew String( "NotFound" );


	WCHAR		*lpAppName;
	WCHAR		*lpKeyName;
	WCHAR		*lpDefault;
	WCHAR		*lpFileName;
	WCHAR		*lpWriteData;


	for ( int nCnt = 0 ; nCnt < 5 ; nCnt++ ) {

		WCHAR				**lpDest;
		array<wchar_t>		^wcsarSource;

		switch ( nCnt ) {
		case 0:		
			lpDest = &lpAppName;
			wcsarSource = m_clsarKeySecInfo[ intDataType ]->strSection->ToCharArray();
			break;
		case 1:		
			lpDest = &lpKeyName;
			wcsarSource = m_clsarKeySecInfo[ intDataType ]->strKey->ToCharArray();
			break;
		case 2:		
			lpDest = &lpDefault;
			wcsarSource = strDefault->ToCharArray();
			break;
		case 3:
			lpDest = &lpFileName;
			wcsarSource = m_strIniFileName->ToCharArray();
			break;
		case 4:
			if ( blWrite == false )
				continue;
			lpDest = &lpWriteData;
			wcsarSource = strData->ToCharArray();
			break;
		}


		(*lpDest) = new WCHAR [ wcsarSource->Length +1 ];

		int nCntCpy;
		for( nCntCpy = 0; nCntCpy < wcsarSource->Length  ; nCntCpy++ ) {
			(*lpDest)[ nCntCpy ] = wcsarSource[ nCntCpy ];
		}
		(*lpDest)[ nCntCpy ] = '\0';


	}


	bool	blRet = false;
	try {

		if ( blWrite == false ) {
			WCHAR		wszRead[ 512 ];

			DWORD dwRet = GetPrivateProfileString(
					lpAppName, 
					lpKeyName,
					lpDefault, 
					wszRead,
					sizeof( wszRead )/ sizeof( WCHAR ), 
					lpFileName
					);
			if ( dwRet == 0 ) {
				throw( -1 );
			}
			if ( wcscmp( wszRead, lpDefault ) == 0 ) {
				throw( -2 );
			}


			strData = gcnew String( wszRead );

			blRet = true;


		} else {

			DWORD dwRet = WritePrivateProfileString(
					lpAppName, 
					lpKeyName,
					lpWriteData,
					lpFileName
				);
			if ( dwRet == 0 ) {
				throw( -3 );
			}		
			blRet = true;


		}
	} catch ( int nErrorCode ) {
		if ( nErrorCode < 0 )
			blRet = false;
	}// finally {
		delete strDefault;
		delete [] lpAppName;
		delete [] lpKeyName;
		delete [] lpDefault;
		delete [] lpFileName;
		if ( blWrite )
			delete [] lpWriteData;

	//}




	return blRet;


}
