#pragma once





namespace nsSvcMHttp
{
	using namespace		System;

	public ref class IniInfo
	{
	public:
		IniInfo();
		~IniInfo();
	

		static ref class KeyTable
		{
		public:
			static const int   STR_HTTPFILE_TOPDIR							= 0;
			static const int   STR_HTTPFILE_DEFAULTNAME						= 1;
			static const int   STR_HTTPFILE_PORT							= 2;
			static const int   STR_HTTPFILE_ACCEPT_MODE						= 3;
			static const int   STR_HTTPFILE_ACCEPT_DOMAIN					= 4;

			static const int   STR_HTTPFILE_UPLOADDIR						= 5;

			static const int   STR_SYSLOGD_FIRSTPPPIP						= 6;

			static const int   STR_NV3MODEM_USEPOLLING						= 7;
			static const int   STR_NV3MODEM_IPADDRESS						= 8;
			static const int   STR_NV3MODEM_USERNAME						= 9;
			static const int   STR_NV3MODEM_PASSWORD						= 10;

			static const int   STR_PRS300MODEM_USEPOLLING					= 11;
			static const int   STR_PRS300MODEM_IPADDRESS					= 12;
			static const int   STR_PRS300MODEM_USERNAME						= 13;
			static const int   STR_PRS300MODEM_PASSWORD						= 14;


			static const int   STR_EXEFILE_PERMIT							= 15;
			static const int   STR_EXEFILE_PERMITFILENAMEPART				= 16;

			static const int   STR_MAILMANAGE_PO3POLLINGTIME_SEC			= 17;


			static const int   STR_MAILMANAGE_POLLMAILSVR_SVRNAME			= 18;
			static const int   STR_MAILMANAGE_POLLMAILSVR_SVRPORT			= 19;
			static const int   STR_MAILMANAGE_POLLMAILSVR_USER				= 20;
			static const int   STR_MAILMANAGE_POLLMAILSVR_PASSWORD			= 21;

			static const int   STR_MAILMANAGE_RETURN_MAILSVR_SVRNAME		= 22;
			static const int   STR_MAILMANAGE_RETURN_MAILSVR_SVRPORT		= 23;
			static const int   STR_MAILMANAGE_RETURN_MAILSVR_MAILADDRESS	= 24;

			static const int   STR_MAILCMD_MAILREACT_GETURL_SUBJECT			= 25;
			static const int   STR_MAILCMD_MAILREACT_PERMIT_MODE			= 26;
			static const int   STR_MAILCMD_MAILREACT_PERMIT_DOMAIN			= 27;

			static const int   STR_DEBUG_DEBUGOUPUT							= 28;


			static const int   STR_INI_MAX									= 29;

		};


		bool ReadIni( int intDataType , String ^%StrData );
		bool ReadIni( int intDataType , Int32 ^%int32Data );

		//bool ReadIni( int intDataType , Object ^%obj );
		bool WriteIni( int intDataType , Object ^%obj );

	private:
		bool IOIni( int intDataType, String ^%strData, bool blWrite );





		ref class clsKeyAndSecs
		{
		public:
			clsKeyAndSecs();
			~clsKeyAndSecs();

			String	^strSection;
			String	^strKey;
		};

		array<nsSvcMHttp::IniInfo::clsKeyAndSecs ^>	^m_clsarKeySecInfo;



		System::String			^m_strIniFileName;
		
	};

	
};
