#pragma once




namespace nsSvcMHttp
{

	using namespace System;
	using namespace System::Threading;



	public ref class LogP
	{
	public:
		LogP();
		~LogP();


	public:
		void StartLogP( void );
		void ExitLogP( void );


		void Open( void );
		void OpenName(                  String ^strLogFileName );
		void OpenNameOF( int nFileNum, String ^strLogFileName );
		void Close( void );
		void CloseOF( int nFileNum );

		void Log(                         String ^strData );
		void LogOF(         int nFileNum, String ^strData );
		void LogWithDate(                 String ^strData );
		void LogOFWithDate( int nFileNum, String ^strData );

	public:
		static bool								m_blAutoFileNameChange_Date;
		String ^GetCurrentLogFileName( void );

	private:
		String^		MakeFileName( void );
		String^		GetFileNameDateStr( void );

		static System::Object					^m_objLock;
		static String							^m_strLogFileName;
		static System::IO::FileStream			^m_fsLog;

		static System::Collections::SortedList	^m_srtFileList;



	};

}