#pragma once


#include "Secures.h"



namespace nsSvcMHttp
{

	using namespace System;




	public ref class IpSecureInf
	{
	public:
		IpSecureInf();
		~IpSecureInf();

		array<Byte>		^m_byarIp;
		array<Byte>		^m_byarIpMask;

		String			^m_strDomain;
		int				m_nPermitMode;

		void SetIpOrDomain( String ^strIp );
		bool IsHitDomain( String ^strChkStr );
		bool IsHitIp(     array<Byte>^	byarIp );

		bool IsHaveIp( void );
		bool IsHaveDomain( void );

		int  RetNetMask( void );
	};


	public ref class IpSecure
	{
	public:
		IpSecure();
		~IpSecure();

	public:
		bool							GetIni( void );
		bool							IsPermitDomain( String ^strCheckData );
		bool							IsPermitIp( array<Byte>^ byarIp );
		System::Collections::ArrayList	^GetAcl( void );
		int								GetDefaultMode( void );

		const static int				m_nMODE_None    = 0;
		const static int				m_nMODE_Permit  = 1;
		const static int				m_nMODE_Deny    = 2;




	protected:
		virtual String ^GetIni_SecName( void ) { return nullptr; };
		virtual String ^GetIni_KeyName( void ) { return nullptr; };



	protected:
		System::Collections::ArrayList	^m_arIpSecInfs;

		int								m_nMode;

		int								RetMode( String ^strMode );
	};



};