#include "stdafx.h"

#include "SyslogD.h"
#include "IoIni.h"


nsSvcMHttp::SysLogD::SysLogD()
{
	m_strLogFileName = nullptr;
	m_SockSyslog = nullptr;
	//m_strPppIp = nullptr;

}

nsSvcMHttp::SysLogD::~SysLogD()
{
	//ExitSysLogD();

}


void nsSvcMHttp::SysLogD::StartSysLogD( void )
{


	m_strPppIp = gcnew String( "0.0.0.0" );
	IniInfo		^pIniInfo = gcnew IniInfo();
	pIniInfo->ReadIni( 
		IniInfo::KeyTable::STR_SYSLOGD_FIRSTPPPIP, 
		m_strPppIp );
	delete pIniInfo;


	m_pLogP = gcnew LogP();

	/* debug */
	Console::WriteLine( "fitst PPPoe IP :{0}", m_strPppIp );



	IPEndPoint^ endPoint = gcnew IPEndPoint( IPAddress::Any, 514  );
	m_SockSyslog = gcnew Socket( endPoint->AddressFamily,SocketType::Dgram  ,ProtocolType::Udp );

	try {
		m_SockSyslog->Bind( endPoint );
	} catch (System::Exception ^e ) {
		
		try { 
			m_SockSyslog->Close();
		} catch ( System::Exception ^e2 ) {
			delete e2;
		}
		delete m_SockSyslog;
		m_SockSyslog = nullptr;
		delete e;

		m_pLogP->LogWithDate( "SyslogD  : |[gI[vɎs܂B" );

	}

}




void nsSvcMHttp::SysLogD::ExitSysLogD( void )
{
	if ( m_strLogFileName )
		delete m_strLogFileName;
	m_strLogFileName = nullptr;

	if ( m_SockSyslog != nullptr ) {
		m_SockSyslog->Close();
		delete m_SockSyslog;
		m_SockSyslog = nullptr;
	}

	if ( m_strPppIp )
		delete m_strPppIp;
	m_strPppIp = nullptr;

	delete m_pLogP;
	m_pLogP = nullptr; 

}





void nsSvcMHttp::SysLogD::ReactSession()
{
	if ( m_SockSyslog == nullptr ) 
		return;

	if ( m_SockSyslog->Poll( 1, SelectMode::SelectRead ) == false )
		return;


	array<Byte>		^byarRcv
		= gcnew array<Byte>( 1024 );
	
	System::Net::IPEndPoint ^sender
					= gcnew IPEndPoint(IPAddress::Any, 0);
	System::Net::EndPoint   ^senderRemote
					= static_cast<System::Net::EndPoint^>(sender);
    
	
	int nRet = m_SockSyslog->ReceiveFrom( byarRcv, senderRemote );

	if ( nRet > 0 ) {

		byarRcv[ nRet ] = '\0';

		array<Byte>		^byarLine
				= gcnew array<Byte>( nRet );

		array<Byte>::Copy( byarRcv, 0, byarLine, 0, nRet );




		System::String		^strRcv;
		strRcv = System::Text::Encoding::ASCII->GetString( byarLine );
		delete byarLine;

		System::String		^strLog
			= String::Concat( "SyslogD  :FROM ", 
							 ( static_cast<IPEndPoint^>(senderRemote) )->Address->ToString(),
							 " DATA: ",
							 strRcv );
		m_pLogP->LogWithDate( strLog );
		delete strLog;

		int nPppIpStrPos = strRcv->IndexOf( "PPPoE1 get IP:" );
		if ( nPppIpStrPos >= 0 ) {

			if ( m_strPppIp != nullptr )
				delete m_strPppIp;
			m_strPppIp = nullptr;

			/* IP 擾 */
			m_strPppIp
				= gcnew String (strRcv->Substring( nPppIpStrPos + 14 ) );
			

			IniInfo		^pIniInfo = gcnew IniInfo();
			pIniInfo->WriteIni( 
				IniInfo::KeyTable::STR_SYSLOGD_FIRSTPPPIP, 
				m_strPppIp );
			delete pIniInfo;

			
			m_pLogP->LogWithDate( "SyslogD  :PPPOE1 O[oAhX"
								  "XV܂BF" + m_strPppIp );

		}


		delete strRcv;

	}


	delete byarRcv;
	delete sender;
	delete senderRemote;

}




void nsSvcMHttp::SysLogD::GetPppIp( System::String ^%strPppIp)
{
	if ( strPppIp != nullptr )
		delete strPppIp;
	strPppIp = nullptr;

	strPppIp = gcnew String( m_strPppIp );

}

